      PROGRAM  ZRAYAMP
C***********************************************************************
C                                                                
C     PROGRAM : ZRAYAMP
C     POUZITI SFER. RYCHLOSTI PRO STRAIN, UPRAVY OZNACENY *********
C     A POUZIT SPRAVNY VZOREC PRO N=0 (VIZ G.MUELLER-EFA)
C     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C     ZATIM ZADAVAME RUCNE V PROGRAMU SFER. RYCHLOST VE ZDROJI PRO 
C     VYPOCET STR., NYNI ZADANO PRO H ZDROJE 700KM. POKUD BY SE
C     NEKDY POCITAL STR. PRO JINE HLOUBKY, MUSI SE TO ZMENIT
C     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C
C ???? JE EKVIVALENTNI PROGRAMU STRAIN (DRIVE STR40) ??? MOZNA AZ NA
C 1.523 X 1.5923, VIZ NIZE
C                                                                
C     PURPOSE : COMPUTES AMPLITUDES ALONG THE RAY
C
C     VERSION : 1997, Q(F)=Q/(0.6366*ATAN(1.5923/F))
C                     QS=QP/2.25
C                     FOR ISOTROPIC SOURCE AS=3*AP-ZATIM NEAPLIK.!!!!
C
C     IMPLEMENT. TRASOVANI PAPRSKU (KINET), VYSTUP DOC(7,*)
C     PRO SYMETRICKY ZDROJ JE AMPLITUDA VE ZDROJI 1000.
C
C     POKUD NECHCEME ODRAZENE VLNY, MUSI BYT VRSTVA, VE KTERE CHCEME
C     REFRAKCI VRSTVOU POSLEDNI. PRESTO SE ALE ZACNE TISKNOUT SESTUPNA
C     CAST PAPRSKU ODRAZENE VLNY PRO NEJVETSI EPICENTRALNI VZDALENOST,
C     NEZ SE PROGRAM ZASTAVI. TUTO CAST PAK MUSIME ODMAZAT. JINAK TO
C     ZARIDIT NEJDE, PROTOZE PAPRSEK NAPRED NEVI, BUDE-LI PATRIT K REFR.
C     CI ODRAZENE VLNE. TEPRVE KDYZ NARAZI NA ROZHRANI, TAK TO VI, ALE TO
C     UZ JE HO KUS VYTISTEN. ZASTAVOVANI PROGRAMU JE PRIKAZEM:
C     IF(K3.EQ.5)STOP    
C
C**********************************************************************
      CHARACTER*80 TEXT
      DIMENSION A(99),B(99),C(99),D(99),H(99),VU(99),VL(99),T(99)
     /,HH(99),HX(99),R1(99),R2(99),C0(99),C1(99),DH(99),AA(99),
     /BB(99),CC(99),DD(99),PT(99),PHH(99),PA(99),PB(99),IU(99), 
     /IL(99),NQ(99),JJ(99),IUG(99),ILG(99),SU(99),SL(99),HN(99),
     /HP(99),BS(99),CS(99),DS(99),QF(99),DST(99),REL(99),AS(99),
     /HLOU(99),TS(99),E(99),EE(99),VUS(99),VLS(99)
C                                  ***************
      COMMON/DIST/DST,ASTART,ASTEP,AFIN,REPS,K2,ITMAX,KX,NDST
      COMMON/OPR/QF,TSTAR,FHZ,NSLO,MWAVE,RAMP,IKSKUP,RZSOUR,RVZD,RROZD,
     /RVAL,RYRO,E,EE
      COMMON/MNMR/A,B,C,D,AS,BS,CS,DS,H,HH,VU,VL,SU,SL,IU,IL,NQ   
     /,IUG,ILG,HN,HP,REL,VZD,ROZD,EPS,ISLO,NIG,IQ   
      COMMON/COD/JJ,KA,K,NISG 
      COMMON/SOUR/ROOZ,VZDP,VZDS,MPSOUR      
      COMMON/REDVEL/REDV
      COMMON/RR/RRXS,RRZS,RRTS,RRTA
      COMMON/SPHER/VUS,VLS,RVZDS
C     ********************
C
      OPEN(5,FILE='zrayamp.dat')
      OPEN(6,FILE='zrayamp.out')
      OPEN(7,FILE='zrayamp.res')
    8 FORMAT(4E13.5/4E13.5,I4/4E13.5)  
      RADS=6371.     
  116 FORMAT(/)
      NRUN=0    
   31 WRITE(6,116)   
      WRITE(6,112)   
  112 FORMAT(2X,' * * * *    P R O G R A M   Z R A Y A M P    * * * * ')
      WRITE(6,116)   
      READ(5,'(A80)')TEXT
      READ(5,*)K2,MPRINT,KX
      REDV=30
      KX=-ABS(KX)
      LU2=1
      NRUN=1      
      WRITE(6,'(A80)')TEXT
      WRITE(6,116)
      WRITE(6,'(A)')'  K2 MPR  KX' 
      WRITE(6,'(3I4,F7.2/)')K2,MPRINT,-KX
      IRUN=1  
      I=0   
      A1=0.
      IQ=1  
      IG=1  
      ISG=1 
      IUG(1)=1       
      IU(1)=1  
      PI=3.142
      WRITE(6,'(A)')'     DEPTHS     VELOCITIES P        DENSITIES      
     /SREL     VS/VP     QF'
   52 I=I+1 
      DA1=A1      
      READ(5,*)H(I),A1,VU(I),D1,E(I),SREL,REL(I),QF(I)     
      VUS(I)=VU(I)
C     ************
      IF(I.GT.1)EE(I-1)=D1
      IF(H(I).LT.(-.9))GO TO 54     
      H(I)=ABS(H(I)) 
      WRITE(6,500)H(I),A1,VU(I),D1,E(I),SREL,REL(I),QF(I)     
      QF(I)=10000.
500   FORMAT(2X,7F9.3,F8.0) 
      IF(I.NE.1)GO TO 502     
      HN(1)=0.       
      HP(1)=E(1)  
      SU(1)=VU(1)*REL(1)      
      NQ(1)=1  
      GO TO 52       
502   IF(A1.LT..1.OR.A1.GT.99.)VL(I-1)=VU(I)    
      IF(A1.GE..1.AND.A1.LE.99.)VLS(I-1)=A1   
      IF(A1.LT..1.OR.A1.GT.99.)VLS(I-1)=VUS(I)    
      IF(A1.GE..1.AND.A1.LE.99.)VL(I-1)=A1   
      SU(I)=VU(I)*REL(I)      
      IF(A1.LT..1.OR.A1.GT.99.)SL(I-1)=SU(I)    
      IF(A1.GE..1.AND.A1.LE.99.)SL(I-1)=VL(I-1)*SREL   
      IF(KX.LT.0.)VL(I-1)=VL(I-1)*RADS/(RADS-H(I))
      IF(KX.LT.0.)VU(I)=VU(I)*RADS/(RADS-H(I))    
      IF(KX.LT.0.)SL(I-1)=SL(I-1)*RADS/(RADS-H(I))
      IF(KX.LT.0.)SU(I)=SU(I)*RADS/(RADS-H(I))    
      IF(KX.LT.0.)H(I)=RADS*ALOG(RADS/(RADS-H(I)))     
701   CONTINUE       
      IF(ABS(VU(I-1)-VL(I-1))/(H(I)-H(I-1)).GT..000002)GO TO 56   
      IF(I.EQ.2)GO TO 47      
      IF(IU(IG).EQ.(I-1))GO TO 47
      IL(IG)=I-2     
      IG=IG+1  
      IU(IG)=I-1     
   47 IL(IG)=I-1     
      IG=IG+1  
      IU(IG)=I       
      GO TO 57       
   56 IF(IU(IG).EQ.(I-1).OR.I.LT.3)GO TO 51 
      IF(VU(I-2).LT.VL(I-2).AND.VU(I-1).LT.VL(I-1))GO TO 51    
      IF(VU(I-2).GT.VL(I-2).AND.VU(I-1).GT.VL(I-1))GO TO 51    
      IL(IG)=I-2     
      IG=IG+1  
      IU(IG)=I-1     
   51 IF(A1.LT..1)GO TO 52    
      IL(IG)=I-1     
      IG=IG+1  
      IU(IG)=I       
   57 IF(A1.GT.99..OR.A1.LT..1)GO TO 52      
      ILG(ISG)=IG-1  
      ISG=ISG+1      
      IUG(ISG)=IG    
      IQ=IQ+1  
      NQ(IQ)=I       
      HN(IQ)=D1
      HP(IQ)=E(I)       
      GO TO 52       
   54 I=I-2 
      NI=I  
      IF(ABS(VU(I)-VL(I))/(H(I+1)-H(I)).LT..000002)IG=IG-1  
      IF(ABS(VU(I)-VL(I))/(H(I+1)-H(I)).LT..000002)GO TO 124      
      IF(DA1.GT..1)IG=IG-1    
  124 NIG=IG      
      IL(IG)=I       
      IF(DA1.GT..1.AND.DA1.LT.99.)NISG=ISG-1    
      IF(DA1.GT..1.AND.DA1.LT.99.)GOTO 59    
      ILG(ISG)=IG    
      IQ=IQ+1  
      NQ(IQ)=I+1     
      NISG=ISG       
   59 NIQ=IQ      
      READ(5,*)OD,TDT   
      IVER=0
      OD=ABS(OD)     
      IF(IVER.EQ.1)READ(5,*)(A(I),B(I),C(I),D(I),I=1,NI)      
      IF(IVER.EQ.0)WRITE(6,117)OD      
  117 FORMAT(/' SMOOTHING PARAMETER  =',F8.3)
      IG=0  
   49 IG=IG+1  
      IF(IG.GT.NIG)GO TO 50   
      IF(NISG.EQ.1)GO TO 86   
      IF(MPRINT.EQ.0)GO TO 86 
      DO 125 JY=2,NISG     
      IF(IUG(JY).EQ.IG)WRITE(6,126)
  126 FORMAT(/2X,'*************************************************')
  125 CONTINUE       
   86 I1=IU(IG)      
      I2=IL(IG)      
      N2=I2+1  
      DO 4 I=I1,I2   
      T(I)=1./VU(I)**2     
      HLOU(I)=H(I)
      HH(I)=H(I)     
    4 CONTINUE
      HH(N2)=H(N2)
      T(N2)=1./VL(I2)**2  
      IF(ABS(VU(I1)-VL(I1))/(H(I1+1)-H(I1)).LT..000002)GOTO 25
      KK=0       
      IF(T(I1).LT.T(N2))KK=1    
      IF(IVER.GE.1)GO TO 25   
      DO 5 I=I1,I2   
    5 DH(I)=OD       
      DH(I1)=0.
      DH(N2)=0.
      IF(KK.EQ.1)GO TO 22     
      DO 21 I=I1,N2  
      J=N2+I1-I      
      PT(I)=T(J)     
   21 PHH(I)=HH(J)   
      GO TO 20       
   22 DO 114 I=I1,N2 
      PT(I)=T(I)     
  114 PHH(I)=HH(I)   
   20 IF(I1.EQ.1)GO TO 36     
      DO 37 I=I1,N2  
      J=I-I1+1       
      PT(J)=PT(I)    
      PHH(J)=PHH(I)  
   37 DH(J)=DH(I)    
      N2=I2-I1+2     
   36 CONTINUE   
      CALL SPLINE(PT,PHH,DH,AA,BB,CC,DD,HX,PA,R1,R2,C0,C1,N2)  
      N3=N2-1  
      N2=I2+1  
      DO 19 I=1,N3   
      AA(I)=AA(I)+BB(I)*PT(I+1)+CC(I)*(PT(I+1))**2+DD(I)*(PT(I+1))**3   
      BB(I)=-BB(I)-2.*CC(I)*PT(I+1)-3.*DD(I)*(PT(I+1))**2      
      CC(I)=CC(I)+3.*DD(I)*PT(I+1)     
   19 DD(I)=-DD(I)   
      IF(I1.EQ.1)GO TO 38     
      DO 39 I=I1,N2  
      J=N2-I+I1      
      K=N2-I+1       
      IF(J.EQ.N2)GO TO 39     
      A(J)=AA(K)     
      B(J)=BB(K)     
      C(J)=CC(K)     
      D(J)=DD(K)     
   39 H(J)=PA(K)     
      GO TO 115      
   38 DO 113 I=I1,N2 
      H(I)=PA(I)     
      IF(I.EQ.N2)GO TO 113    
      A(I)=AA(I)     
      B(I)=BB(I)     
      C(I)=CC(I)     
  113 D(I)=DD(I)     
  115 IF(KK.EQ.1)GO TO 25     
      DO 23 I=I1,N2  
      J=N2+I1-I      
      HX(I)=H(J)
      IF(I.EQ.N2)GO TO 23     
      PA(I)=A(J-1)   
      PB(I)=B(J-1)   
      R1(I)=C(J-1)   
      R2(I)=D(J-1)   
   23 CONTINUE       
      DO 24 I=I1,N2  
      H(I)=HX(I)     
      IF(I.EQ.N2)GO TO 24     
      A(I)=PA(I)     
      B(I)=PB(I)     
      C(I)=R1(I)     
      D(I)=R2(I)     
   24 CONTINUE       
   25 CONTINUE       
      DO 1204 I=I1,I2
      TS(I)=1./SU(I)**2
      H(I)=HLOU(I)
      HH(I)=H(I)
 1204 CONTINUE
      HH(N2)=H(N2)
      TS(N2)=1./SL(I2)**2
      IF(ABS(VU(I1)-VL(I1))/(H(I1+1)-H(I1)).LT..000002) GO TO 1225
      KK=0
      IF(TS(I1).LT.TS(N2))KK=1
      DO 1205 I=I1,I2
 1205 DH(I)=OD
      DH(I1)=0.
      DH(N2)=0.
      IF(KK.EQ.1)GO TO 1222
      DO 1221 I=I1,N2
      J=N2+I1-I
      PT(I)=TS(J)
 1221 PHH(I)=HH(J)
      GO TO 1220
 1222 DO 1314 I=I1,N2
      PT(I)=TS(I)
 1314 PHH(I)=HH(I)
 1220 IF(I1.EQ.1)GO TO 1236
      DO 1237 I=I1,N2
      J=I-I1+1
      PT(J)=PT(I)
      PHH(J)=PHH(I)
 1237 DH(J)=DH(I)
      N2=I2-I1+2
 1236 CONTINUE
      CALL SPLINE(PT,PHH,DH,AA,BB,CC,DD,HX,PA,R1,R2,C0,C1,N2)
      N3=N2-1
      N2=I2+1
      DO 1219 I=1,N3
      AA(I)=AA(I)+BB(I)*PT(I+1)+CC(I)*(PT(I+1))**2+DD(I)*(PT(I+1))**3
      BB(I)=-BB(I)-2.*CC(I)*PT(I+1)-3.*DD(I)*(PT(I+1))**2
      CC(I)=CC(I)+3.*DD(I)*PT(I+1)
 1219 DD(I)=-DD(I)
      IF(I1.EQ.1)GO TO 1238
      DO 1239 I=I1,N2
      J=N2-I+I1
      K=N2-I+1
      IF(J.EQ.N2)GO TO 1239
      AS(J)=AA(K)
      BS(J)=BB(K)
      CS(J)=CC(K)
      DS(J)=DD(K)
 1239 H(J)=PA(K)
      GO TO 1315
 1238 DO 1313 I=I1,N2
      H(I)=PA(I)
      IF(I.EQ.N2)GO TO 1313
      AS(I)=AA(I)
      BS(I)=BB(I)
      CS(I)=CC(I)
 1313 DS(I)=DD(I)
 1315 IF(KK.EQ.1)GO TO 1225
      DO 1223 I=I1,N2
      J=N2+I1-I
      HX(I)=H(J)
      IF(I.EQ.N2)GO TO 1223
      PA(I)=AS(J-1)
      PB(I)=BS(J-1)
      R1(I)=CS(J-1)
      R2(I)=DS(J-1)
 1223 CONTINUE
      DO 1224 I=I1,N2
      H(I)=HX(I)
      IF(I.EQ.N2)GO TO 1224
      AS(I)=PA(I)
      BS(I)=PB(I)
      CS(I)=R1(I)
      DS(I)=R2(I)
 1224 CONTINUE
 1225 CONTINUE
    6 FORMAT(/'       V  A     1/V**2  B       HZ  C       H  D       I'
     //)
      IF(MPRINT.EQ.0)GO TO 49 
      IF(ABS(VU(I1)-VL(I1))/(H(I1+1)-H(I1)).GT..000002)GOTO 40    
      WRITE(6,6)     
      WRITE(6,41)VU(I1),T(I1),HH(I1),H(I1),I1   
   41 FORMAT(2X,F7.3,F8.5,2F8.3,6X,I8) 
      WRITE(6,8)VL(I2),T(N2),HH(N2),H(N2)    
      GO TO 49       
   40 IF(I1.EQ.I2)GO TO 89    
      DO 81 J=I1,I2  
      IF(ABS(D(J)).LT..01)GO TO 1      
      V1=4.*C(J)**2  
      V2=12.*D(J)    
      DIS1=V1-V2*B(J)      
      IF(DIS1.GT.0.)GO TO 82  
702   CONTINUE       
      EPS=.2/(ABS(T(J)-T(J+1)))     
      DIS2=V1-V2*(B(J)+EPS)   
      DIS3=V1-V2*(B(J)-EPS)   
      IF(DIS2.LE.0..AND.DIS3.LE.0.)GO TO 81     
      IF(DIS2.GT.0.)DIS=DIS2  
      IF(DIS3.GT.0.)DIS=DIS3  
      GO TO 90       
   82 DIS=DIS1       
   90 T41=(-2.*C(J)+SQRT(DIS))/(6.*D(J))     
      T42=(-2.*C(J)-SQRT(DIS))/(6.*D(J))     
      IF(T(J).LT.T(J+1))GO TO 91    
      IF(T41.GE.T(J+1).AND.T41.LE.T(J))GO TO 83 
      IF(T42.GE.T(J+1).AND.T42.LE.T(J))GO TO 83 
      GO TO 81       
   91 IF(T41.GE.T(J).AND.T41.LE.T(J+1))GO TO 83 
      IF(T42.GE.T(J).AND.T42.LE.T(J+1))GO TO 83 
      GO TO 81       
    1 IF(ABS(C(J)).LT..01)GOTO 81      
      T41=-B(J)/2./C(J)       
      IF(T(J).LT.T(J+1))GO TO 27    
      IF(T41.GE.T(J+1).AND.T41.LE.T(J))GO TO 83 
      GO TO 81       
   27 IF(T41.GE.T(J).AND.T41.LE.T(J+1))GO TO 83 
   81 CONTINUE       
   89 WRITE(6,6)     
      DO 7 I=I1,I2   
    7 WRITE(6,8)VU(I),T(I),HH(I),H(I),A(I),B(I),C(I),D(I),I,
     /AS(I),BS(I),CS(I),DS(I)
      WRITE(6,8)VL(I2),T(N2),HH(N2),H(N2)    
      IF(MPRINT.LT.2)GO TO 49 
C      IF(TDT.LT..00001)GO TO 49     
      TTDT=TDT       
      WRITE(6,30)    
   30 FORMAT(/2X,'      V      1/V**2       H       DV/DH'/)
      IF(KK.EQ.0)TTDT=-TTDT   
      I=I1-1      
      TT=T(I1)       
   18 I=I+1 
      TT=TT-TTDT     
   16 TT=TT+TTDT     
      IF(KK.EQ.0.AND.TT.LT.T(N2))GO TO 17    
      IF(KK.EQ.1.AND.TT.GT.T(N2))GO TO 17    
      IF(KK.EQ.0.AND.TT.LT.T(I+1))GO TO 18   
      IF(KK.EQ.1.AND.TT.GT.T(I+1))GO TO 18   
      HL=A(I)+B(I)*TT+C(I)*TT**2+D(I)*TT**3     
      HL=ABS(HL)     
703   CONTINUE       
      TV=SQRT(ABS(1./TT))     
      S12=-0.5*TV**7/(B(I)*TV**4+2.0*C(I)*TV**2+3.*D(I)) 
      IF(KX.LT.0)S11=RADS-RADS/EXP(HL/RADS)     
      IF(KX.LT.0)S13=(RADS-S11)*TV/RADS      
      IF(KX.LT.0)WRITE(6,88)TV,TT,HL,S12,S11,S13 
      IF(KX.GT.0)WRITE(6,8)TV,TT,HL,S12      
      GO TO 16       
   17 CONTINUE       
      TT=T(N2)       
      I=I2  
      TV=SQRT(ABS(1./TT))     
      HL=A(I)+B(I)*TT+C(I)*TT**2+D(I)*TT**3     
      S12=-0.5*TV**7/(B(I)*TV**4+2.0*C(I)*TV**2+3.*D(I)) 
      IF(KX.LT.0)S11=RADS-RADS/EXP(HL/RADS)     
      IF(KX.LT.0)S13=(RADS-S11)*TV/RADS      
      IF(KX.LT.0)WRITE(6,88)TV,TT,HL,S12,S11,S13 
      IF(KX.GT.0)WRITE(6,8)TV,TT,HL,S12      
   88 FORMAT(6E13.5)
      GO TO 49       
   50 NAUX=0 
   46 READ(5,*)ICONT,MEP,MOUT,IBP,IBS,IDP,IDS,IREAD,MPSOUR,ITMAX,NLAY      
      IF(NAUX.EQ.0)WRITE(6,493)     
  493 FORMAT(/2X,'ICONT MEP MOUT IBP IBS IDP IDS IREAD MPSOUR MSSOU
     /R ITMAX NLAY') 
      IF(NAUX.EQ.1)WRITE(6,491)     
  491 FORMAT(/2X,'ICONT MEP MOUT IBP IBS IDP IDS IREAD MPSOU
     /R ITMAX NLAY')
      WRITE(6,100)ICONT,MEP,MOUT,IBP,IBS,IDP,IDS,IREAD,
     /MPSOUR,ITMAX,NLAY      
100   FORMAT(3X,15I4)
C      IF(ICONT.EQ.(-1))GO TO 31     
      IF(ICONT.EQ.0)GO TO 99  
C
      NAUX=1      
      IF(ITMAX.EQ.0)ITMAX=20  
      IREC=1      
      IUP=0 
      IUS=0 
      MREG=0      
      IF(MEP.GT.0)GO TO 3     
      NDST=-MEP      
      READ(5,*)(DST(I),I=1,NDST)     
  487 FORMAT(/2X,'DISTANCES') 
      WRITE(6,487)   
      WRITE(6,204)(DST(I),I=1,NDST)    
      RSTEP=(DST(NDST)-DST(1))/FLOAT(NDST-1)    
      GO TO 14       
    3 NDST=MEP       
      READ(5,*)RMIN,RSTEP
      IF(RSTEP.LT..00001)RSTEP=10.     
      WRITE(6,490)   
  490 FORMAT(/4X,'  RMIN     RSTEP') 
      WRITE(6,790)RMIN,RSTEP  
790   FORMAT(2F10.3)
      AR=RMIN  
      DO 13 I=1,MEP  
      DST(I)=AR      
   13 AR=AR+RSTEP    
14    READ(5,*)XSOUR,ZSOUR,TSOUR,REPS,ROZD,FHZ  
      RRXS=XSOUR
      RRZS=ZSOUR
      RRTS=TSOUR
      IF(MPSOUR.EQ.7)CALL SOURCE(0,0,MPSOUR,ANGLE,AMSOUR,PHSOUR)  
      WRITE(6,498)   
  498 FORMAT(/4X,'XSOUR    ZSOUR    TSOUR     REPS      ROZD
     /  FHZ')
      WRITE(6,104)XSOUR,ZSOUR,TSOUR,REPS,ROZD,FHZ    
104   FORMAT(7F9.3)
      IF(KX.LT.0)ZSOUR=RADS*ALOG(RADS/(RADS-ZSOUR))   
      NLAYER=NISG+1-NLAY      
      DO 496 I=1,NISG      
      N5=ILG(I)      
      N5=IL(N5)      
      HWL=H(N5+1)    
704   CONTINUE       
      IF((ZSOUR+.005).LT.HWL)ISOUR=I  
      IF((ZSOUR+.005).LT.HWL)GO TO 486
      IF((ZSOUR-.005).GT.HWL)GO TO 496
      ISOUR=I  
      ZSOUR=HWL-.01  
      GO TO 486      
  496 CONTINUE       
  486 IF(REPS.LT..00001)REPS=.05    
      IF(ROZD.LT..00001)ROZD=1.     
      DLP=ZSOUR      
      IF(DLP.LT.(-.001))WRITE(6,96)    
   96 FORMAT(/2X,'ERROR IN INPUT DATA - SOURCE IS ABOVE THE UPPER BOUNDA
     /RY OF THE MODEL'/)      
      IF(DLP.LT.(-.001))GO TO 99    
      IF(DLP.GT.(H(NI+1)+.001))WRITE(6,93)
   93 FORMAT(/2X,'ERROR IN INPUT DATA - SOURCE IS BELOW THE LOWER BOUNDA
     /RY OF THE MODEL'/)      
      IF(DLP.GT.(H(NI+1)+.001))GO TO 99 
      READ(5,*)AMN1,ASTEP1,AMX1,AMIN2,ASTEP2,AMAX2  
      WRITE(6,488)   
  488 FORMAT(/4X,'  AMN1    ASTEP1      AMX1     AMIN2    ASTEP2     AMA
     /X2')
      WRITE(6,204)AMN1,ASTEP1,AMX1,AMIN2,ASTEP2,AMAX2    
C  
C GENERATE FILE SYNTPL FOR COMPUTATION OF SYNTHETIC SEISMOGRAMS   
C  
      IF(LU2.EQ.0)GO TO 28    
199   FORMAT(I3)
304   FORMAT(5F12.4)
204   FORMAT(8F10.4) 
   28 CONTINUE       
C  
C LOOP FOR ELEMENTARY WAVES   
C  
      NAWX=0      
      IF(MOUT.EQ.0)WRITE(6,105)     
  105 FORMAT(/2X,'LISTING OF WAVE CODES'/2X,'INT.CODE',5X,'E X T E R N A
     / N A L  C O D E')       
      IFIN=0
      NCODE=1
   29 CALL GENER(NAWX,IDP,IDS,IBP,IBS,IUP,IUS,IREAD,ISOUR,IREC,NLAYER,  
     /IFIN,NCODE)    
      NAWX=1    
      IF(IFIN.EQ.1)GO TO 44   
      IF(MOUT.NE.0)WRITE(6,97)      
   97 FORMAT(//2X,'INT.CODE',5X,'E X T E R N A L  C O D E')
      WRITE(6,118)NCODE,K,KA,(JJ(I),I=1,KA)     
  118 FORMAT(I3,2X,25I3)
      IF(MOUT.NE.0)WRITE(6,98)      
   98 FORMAT(/)      
      IF(IFIN.EQ.(-1))GO TO 29      
      EPS=.001       
      ISG=IABS(JJ(1))      
      IS1=IUG(ISG)   
      IS2=ILG(ISG)   
      I11=IU(IS1)    
      I22=IL(IS2)    
705   CONTINUE       
      IF(K.LT.0.AND.DLP.LE.EPS)GO TO 29      
      ASTART=AMN1    
      ASTEP=ASTEP1   
      AFIN=AMX1      
      IF(K .LT.0)ASTART=AMIN2 
      IF(K .LT.0)ASTEP=ASTEP2 
      IF(K .LT.0)AFIN=AMAX2   
      ISLO=0      
      IF(MOUT.GE.1)WRITE(6,60)      
   60 FORMAT(2X,' RECEIVER X-COORD. TIME  HORIZ.VERT.AMPLIT. HORIZ.VERT.
     /PHASE  TSTAR'/) 
      CALL NTRAMP(XSOUR,ZSOUR,TSOUR,NCODE,LU2,MOUT)   
      GO TO 29       
C  
C END OF LOOP FOR ELEMENTARY WAVES     
C  
   44 JJJ=0 
      AR=0.
  119 FORMAT(2I5,F10.3,2E15.8,4F10.5,I3)  
C      GO TO 46       
      GO TO 99
   83 NIG=NIG+1      
      JG=IL(IG)      
      IF(IG+1.EQ.NIG)GO TO 85 
      IK=NIG-IG-1    
      DO 84 K=1,IK   
      K6=NIG-K       
      IU(K6+1)=IU(K6)      
   84 IL(K6+1)=IL(K6)      
   85 IF(J.EQ.I1)GO TO 48     
      IL(IG)=J-1     
      IG=IG+1  
      IU(IG)=J       
      IL(IG)=JG      
      IG=IG-1  
      GO TO 106      
   48 IL(IG)=J       
      IG=IG+1  
      IU(IG)=J+1     
      IL(IG)=JG      
      IG=IG-1  
  106 DO 107 KI=1,NISG     
      IF(IG.LE.ILG(KI))GO TO 108    
  107 CONTINUE       
  108 ILG(KI)=ILG(KI)+1       
      IF(KI.EQ.NISG)GO TO 86  
      KI=KI+1  
      DO 109 IK=KI,NISG       
      IUG(IK)=IUG(IK)+1       
  109 ILG(IK)=ILG(IK)+1       
      GO TO 86       
   99 CONTINUE       
      IF(LU2.EQ.0)GO TO 45    
      NDST=-1  
      CLOSE(UNIT=7,STATUS='KEEP')
   45 STOP  
      END
C
C
      SUBROUTINE GENER(N,IDP,IDS,IBP,IBS,IUP,IUS,IREAD,IS,IR,NS,IFIN,   
     /NCODE)      
C  
C THE ROUTINE GENER IS DESIGNED TO GENERATE NUMERICAL CODES OF 
C ELEMENTARY SEISMIC BODY WAVES     
C  
      DIMENSION JCA(99),JC(99)    
      COMMON/COD/JC,KCA,KC,NISG     
      SAVE INDEX,INEW
C  
      IFIN=0      
      IF(N.GT.0)GO TO 1       
      NCODE=1  
      INEW=1      
      INDEX=1  
      POMT=0.
      GO TO 51       
    1 NCODE=NCODE+1  
      IF(INDEX.GE.11)GO TO 80
      IF(INEW.EQ.1)GO TO 50   
      JAUX=0      
      DO 20 I=1,KCA  
      IF(JCA(I).EQ.JAUX)GO TO 21    
      IAUX=I      
   20 JAUX=JCA(I)    
   21 IF(INDEX.LE.6.AND.JAUX.GE.(NS-1))GO TO 50 
      IF(INDEX.GT.6.AND.JAUX.EQ.1)GO TO 50   
      IAUX1=IAUX+1   
      IAUX2=IAUX+2   
      DO 22 I=IAUX1,KCA       
      II=KCA+IAUX1-I 
      JC(II+2)=JC(II)      
   22 JCA(II+2)=JCA(II)       
      KCA=KCA+2      
      IF(INDEX.GE.7)GO TO 31  
C      WRITE(*,*)IAUX1
      JC(IAUX1)=JAUX+1     
      JC(IAUX2)=JAUX+1     
      JCA(IAUX1)=JC(IAUX1)    
      JCA(IAUX2)=JC(IAUX2)    
      IF(INDEX.GE.5)JC(IAUX1)=-JC(IAUX1)     
      IF(INDEX.EQ.4.OR.INDEX.EQ.5)JC(IAUX2)=-JC(IAUX2)   
      RETURN      
   31 JC(IAUX1)=JAUX-1     
      JC(IAUX2)=JAUX-1     
      JCA(IAUX1)=JC(IAUX1)    
      JCA(IAUX2)=JC(IAUX2)    
      IF(INDEX.GE.9)JC(IAUX1)=-JC(IAUX1)     
      IF(INDEX.EQ.8.OR.INDEX.EQ.9)JC(IAUX2)=-JC(IAUX2)   
      RETURN      
   50 INDEX=INDEX+1  
      INEW=1      
      IF(INDEX.GE.11)GO TO 80 
   51 IF(INDEX.EQ.1.AND.IDP.EQ.0)GO TO 50    
      IF(INDEX.EQ.2.AND.IDS.EQ.0)GO TO 50    
      IF(INDEX.EQ.3.AND.IBP.EQ.0)GO TO 50    
      IF(INDEX.EQ.4.AND.IBP.NE.2)GO TO 50    
      IF(INDEX.EQ.5.AND.IBS.EQ.0)GO TO 50    
      IF(INDEX.EQ.6.AND.IBS.NE.2)GO TO 50    
706   CONTINUE       
      IF(INDEX.EQ.7.AND.IUP.EQ.0)GO TO 50    
      IF(INDEX.EQ.8.AND.IUP.NE.2)GO TO 50    
      IF(INDEX.EQ.9.AND.IUS.EQ.0)GO TO 50    
      IF(INDEX.EQ.10.AND.IUS.NE.2)GO TO 50   
      IMIN=IS  
      IMAX=IR  
      IF(IS.GT.IR)IMIN=IR     
      IF(IS.GT.IR)IMAX=IS     
707   CONTINUE       
      ISUM=IMAX-IMIN+2     
      IF(INDEX.LE.2)GO TO 70  
      INEW=0      
      IF(INDEX.GT.6)GO TO 60  
      ISM=IMAX-IS+1  
      DO 55 I=1,ISM  
      JCA(I)=IS+I-1  
      JC(I)=JCA(I)   
   55 IF(INDEX.GT.4)JC(I)=-JCA(I)      
      ISM2=ISM+1     
      DO 56 I=ISM2,ISUM       
      JCA(I)=IMAX+ISM2-I      
      JC(I)=JCA(I)   
   56 IF(INDEX.EQ.4.OR.INDEX.EQ.5)JC(I)=-JCA(I) 
      KCA=ISUM       
      KC=1  
      RETURN      
   60 ISM=IS-IMIN+1  
      DO 65 I=1,ISM  
      JCA(I)=IS+1-I  
      JC(I)=JCA(I)   
   65 IF(INDEX.GT.8)JC(I)=-JCA(I)      
      ISM2=ISM+1     
      DO 66 I=ISM2,ISUM       
      JCA(I)=IMIN+I-ISM2      
      JC(I)=JCA(I)   
   66 IF(INDEX.EQ.8.OR.INDEX.EQ.9)JC(I)=-JCA(I) 
      KCA=ISUM       
      KC=-1 
      INEW=0      
      RETURN      
   70 KCA=IMAX-IMIN+1      
      KC=1  
      IF(IS.GE.IR)KC=-1       
      DO 71 I=1,KCA  
      JC(I)=IS+I-1   
      IF(IS.GT.IR)JC(I)=IS-I+1      
      JCA(I)=JC(I)   
      IF(INDEX.EQ.2)JC(I)=-JC(I)    
   71 CONTINUE       
      RETURN      
   80 IF(IREAD.EQ.0)GO TO 101 
      READ(5,*)KC,KCA,(JC(I),I=1,KCA)      
      IF(KCA.EQ.0)GO TO 101   
      DO 81 I=1,KCA  
   81 JCA(I)=IABS(JC(I))      
      IF(KCA.GT.50)GO TO 99   
      JAUX=JCA(1)    
      IF(JAUX.NE.IS.OR.IS.LE.0.OR.IS.GT.NS)GO TO 99   
      IF(JCA(KCA).NE.IR.OR.IR.LE.0.OR.IR.GT.NS)GO TO 99  
      IF(KCA.EQ.1)RETURN      
      ID=1  
      IF(KC.LT.0)ID=-1     
708   CONTINUE       
      DO 103 I=2,KCA 
      JJ=JCA(I)      
      IF(JJ.LE.0.OR.JJ.GE.NS)GO TO 99  
      IF(JJ.EQ.JAUX)GO TO 105 
      IF(ID.EQ.1.AND.JJ.EQ.(JAUX+1))GO TO 103   
      IF(ID.EQ.(-1).AND.JJ.EQ.(JAUX-1))GO TO 103      
      GO TO 99       
  105 ID=-ID      
  103 JAUX=JJ  
      RETURN      
   99 IFIN=-1  
      RETURN      
  101 IFIN=1      
      RETURN      
  100 FORMAT(24I3)   
      END 
C
C  
      SUBROUTINE NTRAMP(XSOUR,ZSOUR,TSOUR,NCODE,LU2,MOUT)      
C  
      DIMENSION DST(99),QF(99),E(99),EE(99)
      COMMON/DIST/DST,ASTART,ASTEP,AFIN,REPS,K2,ITMAX,KX,NDST
      COMMON/OPR/QF,TSTAR,FHZ,NSLO,MWAVE,RAMP,IKSKUP,RZSOUR,RVZD,RROZD,
     /RVAL,RYRO,E,EE
      COMMON/REDVEL/REDV
      INDS=0
      K3=0  
      AA=ASTART-ASTEP      
      INDEX=0  
      INUM=0      
      NSLO=0      
C     LOOP IN RAY PARAMETERS AA, FROM ASTART TO AFIN, WITH THE STEP     
C     ASTEP 
      ADA=0.01       
    1 AA=AA+ASTEP    
      IF(ABS(AA).GT.(ADA-.000001))GO TO 5
      IF(ASTEP.GT.0.)AB=.000001     
      IF(ASTEP.LT.0.)AB=-.000001    
      K3=K2 
      K7=0  
      XO=XSOUR       
      YO=ZSOUR       
      TO=TSOUR       
      IND=INDS       
      AO=AB 
      NSLO=2      
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      NSLO=0      
      IF(MOUT.EQ.2)WRITE(6,*)IND,XO,AB     
      IF(IND.NE.3.AND.AB.GT.0.)AA=ADA  
      IF(IND.NE.3.AND.AB.LT.0.)AA=-ADA 
      IF(IND.NE.3)GO TO 8     
      TO1=TO      
      XO1=XO      
      AJZ1=AB  
      IF(AB.GT.0.)AC=0.01     
      IF(AB.LT.0.)AC=-0.01    
      XO=XSOUR       
      YO=ZSOUR       
      TO=TSOUR       
      IND=INDS       
      AO=AC 
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      IF(IND.NE.3.AND.AB.GT.0.)AA=ADA  
      IF(IND.NE.3.AND.AB.LT.0.)AA=-ADA 
      IF(IND.NE.3)GO TO 8     
      AMZ2=AMPZ      
      AMX2=AMPX      
      PHZ2=PHAZ      
      PHX2=PHAX      
      TSTAR2=TSTAR
      TO2=TO      
      XO2=XO      
      AJZ2=AC  
      IF(AB.GT.0.)AD=0.015    
      IF(AB.LT.0.)AD=-0.015   
      XO=XSOUR       
      YO=ZSOUR       
      TO=TSOUR       
      IND=INDS       
      AO=AD 
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      IF(IND.NE.3.AND.AB.GT.0.)AA=ADA  
      IF(IND.NE.3.AND.AB.LT.0.)AA=-ADA 
      IF(IND.NE.3)GO TO 8     
      AMZ3=AMPZ      
      AMX3=AMPX      
      PHZ3=PHAZ      
      PHX3=PHAX      
      TSTAR3=TSTAR
      XO3=XO      
   11 V87=(XO1-XO3)/(XO2-XO3) 
      AMZ1=AMZ3+(AMZ2-AMZ3)*V87     
      AMX1=AMX3+(AMX2-AMX3)*V87     
      PHZ1=PHZ3+(PHZ2-PHZ3)*V87     
      PHX1=PHX3+(PHX2-PHX3)*V87     
      TSTAR1=TSTAR3+(TSTAR2-TSTAR3)*V87
      IF(IABS(KX).NE.2)GO TO 621
      RX=AJZ2-AJZ1
      AA=AA-ASTEP
  622 AA=AA+ASTEP
      IF(ABS(AA).GT.0.00999)GO TO 8 
      RM=(AA-AJZ1)/RX
      XO=XO1+(XO2-XO1)*RM
      TO=TO1+(TO2-TO1)*RM
      AMPX=AMX1+(AMX2-AMX1)*RM      
      AMPZ=AMZ1+(AMZ2-AMZ1)*RM      
      PHAX=PHX1+(PHX2-PHX1)*RM      
      PHAZ=PHZ1+(PHZ2-PHZ1)*RM      
      IF(AMPZ.GT..1E-20)AMLOGZ=ALOG10(AMPZ)+7.06      
      TSTAR=TSTAR1+(TSTAR2-TSTAR1)*RM
      IF(MOUT.GE.1)WRITE(6,999)AA,XO,TO,AMPX,AMPZ,PHAX,PHAZ,TSTAR
      IF(REDV.GT.1)REDTO=TO-XO/REDV
      GO TO 622
  621 RX=XO2-XO1     
      DO 7 I=1,NDST  
      IF(XO1.LT.XO2)GO TO 12  
      J=NDST-I+1
      IF(DST(J).LT.XO2)GO TO 8      
      IF(DST(J).GT.XO1)GO TO 7      
      DD=DST(J)      
      IJ=J
      GO TO 13       
   12 IF(DST(I).LT.XO1)GO TO 7      
      IF(DST(I).GT.XO2)GO TO 8      
      DD=DST(I)      
      IJ=I
   13 RM=(DD-XO1)/RX 
      TO=TO1+(TO2-TO1)*RM     
      AJZ=AJZ1+(AJZ2-AJZ1)*RM 
      AMPX=AMX1+(AMX2-AMX1)*RM      
      AMPZ=AMZ1+(AMZ2-AMZ1)*RM      
      PHAX=PHX1+(PHX2-PHX1)*RM      
      PHAZ=PHZ1+(PHZ2-PHZ1)*RM      
      TSTAR=TSTAR1+(TSTAR2-TSTAR1)*RM
      IF(AMPZ.GT..1E-20)AMLOGZ=ALOG10(AMPZ)+7.06
      IF(MOUT.GE.1)WRITE(6,999)AJZ,DD,TO,AMPX,AMPZ,PHAX,PHAZ,TSTAR
      IF(REDV.GT.1)REDTO=TO-DD/REDV
    7 CONTINUE       
    8 IF(K7.EQ.1)GO TO 99     
      IF(AA.GT.0.)AA=ADA      
      IF(AA.LT.0.)AA=-ADA     
      AA=AA-ASTEP    
      K3=0  
      GO TO 1  
    5 IF(ASTEP.GT.0..AND.AA.GT.AFIN)GO TO 99    
      IF(ASTEP.LT.0..AND.AA.LT.AFIN)GO TO 99    
      IF(ABS(AA).LT.3.13001)GO TO 10   
      IF(AA.GT.0.)AA=3.125    
      IF(AA.LT.0.)AA=-3.125   
      K7=1  
      K3=K2 
      XO=XSOUR       
      YO=ZSOUR       
      TO=TSOUR       
      IND=INDS       
      AO=AA 
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      IF(IND.NE.3)GO TO 99    
      AMZ3=AMPZ      
      AMX3=AMPX      
      PHZ3=PHAZ      
      PHX3=PHAX      
      TSTAR3=TSTAR
      XO3=XO      
      IF(AA.GT.0.)AA=3.13     
      IF(AA.LT.0.)AA=-3.13    
      XO=XSOUR       
      YO=ZSOUR       
      TO=TSOUR       
      IND=INDS       
      AO=AA 
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      IF(IND.NE.3)GO TO 99    
      AMZ2=AMPZ      
      AMX2=AMPX      
      PHZ2=PHAZ      
      PHX2=PHAX      
      TSTAR2=TSTAR
      TO2=TO      
      XO2=XO      
      IF(AA.GT.0.)AA=3.141592 
      IF(AA.LT.0.)AA=-3.141592      
      XO=XSOUR       
      YO=ZSOUR       
      TO=TSOUR       
      IND=INDS       
      AO=AA 
      NSLO=2      
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      IF(MOUT.EQ.2)WRITE(6,*)IND,XO,AA     
      IF(IND.NE.3)GO TO 99    
      TO1=TO      
      XO1=XO      
      GO TO 11       
   10 XO=XSOUR       
      YO=ZSOUR       
      TO=TSOUR       
      IND=INDS       
      AO=AA 
      IF(IABS(KX).EQ.2)K3=K2  
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      IF(IABS(KX).NE.2)GO TO 998    
      IF(MOUT.EQ.2)WRITE(6,*)IND,XO,AA     
      IF(IND.NE.3)GO TO 1     
      IF(K3.EQ.5)GO TO 1      
      IF(AMPZ.GT..1E-20)AMLOGZ=ALOG10(AMPZ)+7.06
      WRITE(6,999)AO,XO,TO,AMPX,AMPZ,PHAX,PHAZ,TSTAR  
      IF(REDV.GT.1)REDTO=TO-XO/REDV
  999 FORMAT(1X,F9.5,2F10.3,2E11.4,F7.3,F7.3,F7.4)
C
      IF(INUM.EQ.0)GO TO 1    
  998 IF(MOUT.EQ.2)WRITE(6,*)IND,XO,AA     
  100 FORMAT(I3,2F10.5)       
      IF(IND.NE.3)GO TO 1     
      IF(INUM.NE.0)GO TO 2    
      AOLD=AA  
      IOLD=IND       
      XOLD=XO  
      INUM=1      
      GO TO 1  
C  
C     PARAMETERS FOR THE PRECEEDING RAY: AA=AOLD, XO=XOLD, IND=IOLD     
C     PARAMETERS FOR THE NEW RAY: AA=ANEW, XO=XNEW, IND=INEW   
C  
2     INEW=IND       
      ANEW=AA  
      XNEW=XO  
      IF(INEW.EQ.3.AND.IOLD.EQ.3)GO TO 40    
      IF(INEW.EQ.3)GO TO 50   
      IF(IOLD.EQ.3)GO TO 55   
      IF(INEW.EQ.9.AND.IOLD.NE.9)GO TO 30    
      IF(INEW.NE.9.AND.IOLD.EQ.9)GO TO 35    
C  
C     NO ITERATIONS, TAKE A NEW RAY IN THE LOOP 
C  
3     IOLD=INEW      
      XOLD=XNEW      
      AOLD=ANEW      
      GO TO 1  
C  
C     REGULAL CASE: IOLD=3, INEW=3     
C  
40    XXNEW=XNEW     
      XXOLD=XOLD     
      AANEW=ANEW     
      AAOLD=AOLD     
41    IF(XXNEW.GT.XXOLD)GO TO 46    
C  
C     REGULAR CASE: XXNEW.LE.XXOLD, ITREND=-1 (REVERSE BRANCH) 
C  
      ITREND=-1      
      DO 42 I=1,NDST 
      NDD=NDST-I+1   
      IF(DST(NDD).GT.XXOLD)GO TO 42    
      IF(DST(NDD).LT.XXNEW)GO TO 3     
      DD=DST(NDD)    
      II=NDD      
      GO TO 43       
42    CONTINUE       
      GO TO 3  
C  
C     REGULAR CASE: XXNEW.GT.XXOLD, ITREND=1 (REGULAR BRANCH)  
C  
  46  ITREND=1       
      DO 44 I=1,NDST 
      IF(DST(I).LT.XXOLD) GO TO 44     
      IF(DST(I).GT.XXNEW) GO TO 3      
      DD=DST(I)      
      II=I  
      GO TO 43       
44    CONTINUE       
      GO TO 3  
43    P1=AAOLD       
      P2=AANEW       
      X1=XXOLD       
      X2=XXNEW       
C  
C     I T E R A T I O N S     
C  
60    ITER=0      
61    PNEW=0.5*(P1+P2)     
      ITER=ITER+1    
      IF(ITER.GT.ITMAX)GO TO 80     
      XO=XSOUR       
      YO=ZSOUR       
      TO=TSOUR       
      IND=INDS       
      AO=PNEW  
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      IF(MOUT.EQ.2)WRITE(6,101)IND,ITER,DD,XO,PNEW    
101   FORMAT(2I3,3F12.5)      
      IF(IND.NE.3)P2=PNEW     
      IF(IND.NE.3)GO TO 61    
      IF(ABS(XO-DD).LT.REPS)GO TO 65   
      IF(X1.LT.X2.AND.DD.LT.XO)GO TO 62      
      IF(X1.LT.X2.AND.DD.GT.XO)GO TO 63      
      IF(X1.GT.X2.AND.DD.LT.XO)GO TO 63      
62    P2=PNEW  
      X2=XO 
      GO TO 61       
C  
C     SUCCESFULL ITERATIONS   
C  
63    P1=PNEW  
      X1=XO 
      GO TO 61       
65    INDEX=INDEX+1  
      IF(K2.LT.1)GO TO 4      
      K3=K2 
      XO=XSOUR       
      TO=TSOUR       
      K4=0  
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      IF(K3.EQ.5)K4=1      
      K3=0  
      IF(K4.EQ.1)GO TO 80     
CC      IF((PHAX-PI).LE.0.1) PHAX=0.
      IF(AMPZ.GT..1E-20)AMLOGZ=ALOG10(AMPZ)+7.06
4     IF(MOUT.GE.1)WRITE(6,999) AO,DD,TO,AMPX,AMPZ,PHAX,PHAZ,TSTAR
      IF(REDV.GT.1)REDTO=TO-DD/REDV
C  
80    P1=PNEW  
      X1=XO 
      IF(ITER.GT.ITMAX)P1=AAOLD     
      IF(ITER.GT.ITMAX)X1=XXOLD     
      P2=AANEW       
      X2=XXNEW       
      IF(ITREND.EQ.(-1))GO TO 85    
      II=II+1  
      IF(II.GT.NDST)GO TO 3   
      DD=DST(II)     
      IF(DD.GT.XXNEW)GO TO 3  
      GO TO 60       
85    II=II-1  
      IF(II.LT.1)GO TO 3      
      DD=DST(II)     
      IF(DD.LT.XXNEW)GO TO 3  
      GO TO 60       
C  
C     E N D  O F  I T E R A T I O N S  
C  
C     BOUNDARY RAYS. CASE IOLD.NE.3, INEW=3     
C  
   50 XXNEW=XNEW     
      AANEW=ANEW     
      P1=AOLD  
      P2=ANEW  
   54 IRES=0      
      ITER=0      
   51 PNEW=0.5*(P1+P2)     
      ITER=ITER+1    
      XO=XSOUR       
      YO=ZSOUR       
      TO=TSOUR       
      IND=INDS       
      AO=PNEW  
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      IF(MOUT.EQ.2)WRITE(6,103)IND,ITER,XO,PNEW 
      IF(IND.EQ.3)GO TO 52    
      P1=PNEW  
      GO TO 53       
   52 IRES=1      
      XXOLD=XO       
      AAOLD=PNEW     
      P2=PNEW  
   53 IF(ITER.GE.ITMAX.AND.IRES.EQ.1)GO TO 41   
      IF(ITER.GE.ITMAX)GO TO 3      
      GO TO 51       
C  
C     BOUNDARY RAYS. CASE IOLD=3, INEW.NE.3     
C  
   55 XXOLD=XOLD     
      AAOLD=AOLD     
      P1=AOLD  
      P2=ANEW  
   59 IRES=0      
      ITER=0      
   56 PNEW=0.5*(P1+P2)     
      ITER=ITER+1    
      XO=XSOUR       
      YO=ZSOUR       
      TO=TSOUR       
      IND=INDS       
      AO=PNEW  
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      IF(MOUT.EQ.2)WRITE(6,103)IND,ITER,XO,PNEW 
  103 FORMAT(2X,'SH',2X,2I5,2F12.5)    
      IF(IND.EQ.3)GO TO 57    
      P2=PNEW  
      GO TO 58       
   57 IRES=1      
      XXNEW=XO       
      AANEW=PNEW     
      P1=PNEW  
   58 IF(ITER.GE.ITMAX.AND.IRES.EQ.1)GO TO 41   
      IF(ITER.GE.ITMAX)GO TO 3      
      GO TO 56       
C  
C     CRITICAL RAYS. CASE IOLD.NE.9, INEW=9     
C  
   30 ITER=0      
      P1=AOLD  
      P2=ANEW  
      IRES=0      
   31 PNEW=0.5*(P1+P2)     
      ITER=ITER+1    
      XO=XSOUR       
      YO=ZSOUR       
      TO=TSOUR       
      IND=INDS       
      AO=PNEW  
      CALL MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      IF(MOUT.EQ.2)WRITE(6,104)IND,ITER,XO,PNEW 
  104 FORMAT(2X,'CR',2I4,7F12.5/10X,7F12.5) 
      IF(IND.EQ.9)GO TO 32    
      IF(IND.EQ.3)GO TO 33    
      P1=PNEW  
      GO TO 34       
   32 P2=PNEW  
      GO TO 34       
   33 IRES=1      
      P1=PNEW  
   34 IF(ITER.GE.ITMAX.AND.IRES.EQ.0)GO TO 3    
      IF(ITER.LT.ITMAX)GO TO 31     
      P2=PNEW  
      XXNEW=XO       
      AANEW=P2       
      P1=AOLD  
      GO TO 54       
C  
C     CRITICAL RAYS. CASE IOLD=9, INEW.NE.9, INEW.NE.3   
C     (THIS VERSION NOT YET WRITTEN)   
C  
   35 CONTINUE       
      GO TO 3  
  115 FORMAT(2I5,F10.3,2E15.8,4F10.5,I3)  
   99 RETURN      
      END   
C
C
      SUBROUTINE MRAY(K3,XO,YO,AO,TO,IND,AMPZ,AMPX,PHAZ,PHAX)  
      DIMENSION A(99),B(99),C(99),D(99),H(99),VU(99),VL(99),HH(99)
     /,BS(99),CS(99),DS(99),SU(99),SL(99),IU(99),IL(99),NQ(99)
     /,JJ(99),IUG(99),ILG(99),HN(99),HP(99),QF(99),DST(99),REL(99)
     /,AS(99),E(99),EE(99),VUS(99),VLS(99)
C                          ***************
      COMMON/OPR/QF,TSTAR,FHZ,NSLO,MWAVE,RAMP,IKSKUP,RZSOUR,RVZD,RROZD,
     /RVAL,RYRO,E,EE
      COMMON/DIST/DST,ASTART,ASTEP,AFIN,REPS,K2,ITMAX,KX,NDST
      COMMON/MNMR/A,B,C,D,AS,BS,CS,DS,H,HH,VU,VL,SU,SL,IU,IL,NQ   
     /,IUG,ILG,HN,HP,REL,VZD,ROZD,EPS,ISLO,NIG,IQ   
      COMMON/COD/JJ,KA,K,NISG 
      COMMON/SOUR/ROOZ,VZDP,VZDS,MPSOUR      
      COMMON/RR/RRXS,RRZS,RRTS,RRTA
      COMMON/SPHER/VUS,VLS,RVZDS
C     ********************      
      IF(ABS(AO).GT.1.57079)P=ABS(AO)-1.57079   
      IF(ABS(AO).LE.1.57079)P=1.57079-ABS(AO)   
      ANGLE=AO       
C  
      ROOZ=ROZD      
      RROZD=ROZD
      IF(JJ(1).GT.0)MWAVE=1   
      IF(JJ(1).LT.0)MWAVE=2   
      ENTF=0.
      RTIME=0.
      RVAL=0.
      IKSKUP=0
      RZSOUR=YO
      NDER=0
      KROK=0
      RADS=6371.     
      DLP=YO      
      DX=0.
      DT=0.
      DDE=0.
      TSTAR=0.       
      K1=0  
      KS=0  
C      IF(K.GT.0)IZNAM=1       
C      IF(K.LT.0)IZNAM=-1      
709   CONTINUE       
      RYRO=1.  
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
      AMP=1000.      
      RVZDS=10.8963
C     ********
C RVZDS PRO 700 KM=10.8963
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C MULTIPLICATION OF S RADIATION FOR ISOTROPIC SOURCE
      IF(MPSOUR.EQ.0.AND.JJ(1).LT.0)AMP=AMP*3.   
      PHA=0.      
      ISLO=ISLO+1    
      IF(K.GT.0)GO TO 69    
C  
C URCENI RYCHLOSTI VE ZDROJI
C
      DO 72 J=1,NIG  
      KR=NIG+1-J     
      I1=IU(KR)      
      I2=IL(KR)      
      IF(H(I1)+.002.LT.DLP)GO TO 73    
   72 CONTINUE       
   73 DL1=DLP
      DDL1=DL1       
      II1=I1      
      II2=I2      
      DL2=H(I1)      
      DDL2=DL2       
      IF(I1.EQ.I2.AND.ABS(VU(I1)-VL(I1))/(HH(I1+1)-HH(I1)).LT..000002)
     /VZD=VU(I1) 
      IF(I1.EQ.I2.AND.ABS(VU(I1)-VL(I1))/(HH(I1+1)-HH(I1)).LT..000002)
     /GOTO1
      IF(ABS(DL1-H(I2+1)).LT..002)VZD=VL(I2)    
      IF(ABS(DL1-H(I2+1)).LT..002)GO TO 1    
      J=I2+1      
    5 J=J-1 
      IF(H(J).GE.DL1)GO TO 5  
      VN=VU(J)       
      VD=VL(J)       
      HNN=H(J)       
      HD=H(J+1)      
      ZZ=DL1
   31 V=VN+(ZZ-HNN)*(VD-VN)/(HD-HNN)
      FV=A(J)+B(J)/V**2+C(J)/V**4+D(J)/V**6     
      IF(ABS(FV-ZZ).LT..05)GO TO 52   
      IF(FV.GT.ZZ)GO TO 53     
      VN=V  
      HNN=FV      
      GO TO 31       
   53 VD=V  
      HD=FV 
      GO TO 31       
   52 VZD=V 
    1 VZDP=VZD       
      IF(KX.LT.0)VZDP=VZDP/EXP(DLP/RADS)     
      VZDS=VZDP*REL(J)     
      IF(JJ(1).LT.0)VZD=VZD*REL(J)     
      P=ABS(SIN(P)/VZD)       
      RVZD=VZD
      GO TO 68       
C
C
   69 DO 70 J=1,NIG  
      KR=J  
      I1=IU(KR)      
      I2=IL(KR)      
      IF((H(I2+1)-.002).GT.DLP)GO TO 71  
   70 CONTINUE       
   71 DL1=DLP
      DDL1=DL1       
      II1=I1      
      II2=I2      
      DL2=H(I2+1)    
      DDL2=DL2       
      IF(I1.EQ.I2.AND.ABS(VU(I1)-VL(I1))/(HH(I1+1)-HH(I1)).LT..000002)
     /VZD=VU(I1) 
      IF(I1.EQ.I2.AND.ABS(VU(I1)-VL(I1))/(HH(I1+1)-HH(I1)).LT..000002)
     /GO TO 11    
      IF(ABS(DL1-H(I1)).LT..002)VZD=VU(I1)   
      IF(ABS(DL1-H(I1)).LT..002)GO TO 11     
      J=I1-1      
   15 J=J+1 
      IF(H(J+1).LE.DL1)GO TO 15     
      VN=VU(J)       
      VD=VL(J)       
      HNN=H(J)       
      HD=H(J+1)      
      ZZ=DL1      
   41 V=VN+(ZZ-HNN)*(VD-VN)/(HD-HNN)   
      FV=A(J)+B(J)/V**2+C(J)/V**4+D(J)/V**6     
      IF(ABS(FV-ZZ).LT..05)GO TO 62   
      IF(FV.GT.ZZ)GO TO 63    
      VN=V  
      HNN=FV  
      GO TO 41       
   63 VD=V  
      HD=FV 
      GO TO 41       
   62 VZD=V 
   11 VZDP=VZD       
      IF(KX.LT.0)VZDP=VZDP/EXP(DLP/RADS)     
      VZDS=VZDP*REL(J)     
      IF(JJ(1).LT.0)VZD=VZD*REL(J)     
      P=ABS(SIN(P)/VZD)       
      RVZD=VZD
C
C KONEC URCENI RYCHLOSTI
C
   68 CONTINUE
      IF(MPSOUR.EQ.0)GO TO 718      
      CALL SOURCE(0,MWAVE,MPSOUR,ANGLE,AMSOUR,PHSOUR)    
      AMP=AMP*AMSOUR 
      PHA=PHA+PHSOUR 
  718 CONTINUE       
C      RRTA=ALOG10(AMP)
C      STRAI=4.*AMP*FHZ/RVZDS
C           **             *
C
C TISK UDAJU PRO ZDROJ
C         IF(K3.GT.1)WRITE(7,*)RRXS,RRZS,RRTS,RRTA,AMP
C         IF(K3.GT.1)WRITE(7,375)RRXS*.00899322,RRZS,RRTS,STRAI,AMP
      IF(K3.GT.1)WRITE(7,375)RRXS*.00899322,RRZS
  375 FORMAT(3F12.4,2F12.5) 
      RAMP=AMP
      I=1   
      ISG=IABS(JJ(I))      
      IS1=IUG(ISG)   
      IS2=ILG(ISG)   
      IF(K.GT.0)GO TO 13      
      II=IS2+1       
   98 II=II-1  
      I1=IU(II)      
      I2=IL(II)      
      II1=I1      
      II2=I2      
      IF((H(I1)+EPS/2.).LE.DLP.AND.H(I2+1).GE.(DLP-EPS))GO TO 97
      GO TO 98       
   97 IG=II 
      IIG=IG      
      DL1=DLP  
      DL2=H(I1)      
      DDL1=DL1       
      DDL2=DL2       
      GO TO 32       
   13 II=IS1-1       
   99 II=II+1  
      I1=IU(II)      
      I2=IL(II)      
      II1=I1      
      II2=I2      
      IF((H(I1)-EPS/2.).LE.DLP.AND.H(I2+1).GT.(DLP+EPS))GO TO 101
      GO TO 99       
  101 IG=II 
      IIG=IG      
      DL1=DLP  
      DL2=H(I2+1)    
      DDL1=DL1       
      DDL2=DL2       
      GO TO 32       
    2 I=I+1 
      IF(I.GT.KA.AND.K1.EQ.1)IND=18    
      IF(I.GT.KA.AND.K1.EQ.1)GO TO 76  
      IF(I.GT.KA)GO TO 111    
      ISG=IABS(JJ(I))      
      IS1=IUG(ISG)   
      IS2=ILG(ISG)   
710   CONTINUE       
      IF(IABS(JJ(I)).GT.IABS(JJ(I-1)))GO TO 35  
      IF(IABS(JJ(I)).LT.IABS(JJ(I-1)))GO TO 42  
      IF(K1.NE.1)GO TO 66     
      DL9=DL2  
      IF(DL1.GT.DL9)DL2=H(I2+1)     
      IF(DL1.LT.DL9)DL2=H(I1) 
      DL1=Z 
      GO TO 32       
   66 IF(DL1.LT.DL2)GO TO 64  
      IF(I.EQ.KA)IND=14       
      IF(I.EQ.KA)GO TO 76     
      DL1=H(I1)      
      DL2=H(I2+1)    
      IF(K3.NE.2)GO TO 139    
711   CONTINUE       
C
C SKUPINA: VLNA DOPADA ZDOLA A ODRAZI SE DOLU
C TATO CAST NENI UPRAVENA!!!!!!!!!!!!!!!!!!!!
C
      IKSKUP=1
C
      NY=IABS(JJ(I-1))     
      NYI=IU(IS1)    
      VP1=VU(NYI)    
      VP1S=VUS(NYI)
C     *************
      VS1=SU(NYI)    
      IF(IABS(JJ(I)).EQ.1)GO TO 140    
      VP2=VL(NYI-1)
      VP2S=VLS(NYI-1)  
C     ***************
      VS2=SL(NYI-1)  
  140 RO1=HP(NY)     
      RO2=HN(NY)     
      IF(JJ(I-1).GT.0)GO TO 141     
      IF(JJ(I).GT.0)GO TO 142 
C ODRAZ S NA S OD VOLNE
      IF(IABS(JJ(I)).EQ.1)NCODE=4      
C ODRAZ S NA S ZDOLA DOLU
      IF(IABS(JJ(I)).NE.1)NCODE=6      
      GO TO 143  
C ODRAZ S NA P OD VOLNE    
  142 IF(IABS(JJ(I)).EQ.1)NCODE=3
C ODRAZ S NA P ZDOLA DOLU      
      IF(IABS(JJ(I)).NE.1)NCODE=5      
      RYRO=RYRO*VP1/VS1*SQRT(ABS((1.-(P*VP1)**2)/(1.-(P*VS1)**2)))      
      GO TO 143      
  141 IF(JJ(I).GT.0)GO TO 144 
C ODRAZ P NA S ZDOLA DOLU OBECNE I OD VOLNE 
      NCODE=2  
      RYRO=RYRO*VS1/VP1*SQRT(ABS((1.-(P*VS1)**2)/(1.-(P*VP1)**2)))      
      GO TO 143      
C ODRAZ P NA P ZDOLA DOLU OBECNE I OD VOLNE
  144 NCODE=1  
  143 CONTINUE
C      IZNAM=-IZNAM   
      ND=0  
      IF(ABS(AO).LE.1.570796)ND=1      
      CALL COEF50(P,VP1,VS1,RO1,VP2,VS2,RO2,NCODE,ND,RMOD,RPH) 
      AMP=AMP*RMOD   
C
CC            AMP=AMP*SQRT(ABS(RYRO*VZD*ROZD/VP2/RO2))
C
C TATO CAST NENI DODELANA, PRO NORM. SITUACI NEPRICHAZI V UVAHU.
C (JEN  PRO PP A PP Z PODELNYCH VLN, A TY ZATIM NEDELAT)
C
      PHA=PHA+RPH    
  139 GO TO 32       
   64 DL1=H(I2+1)    
      DL2=H(I1)      
      IF(K3.NE.2)GO TO 134    
      NY=IABS(JJ(I-1))     
      NYI=IL(IS2)    
      VP1=VL(NYI)    
      VP1S=VLS(NYI)
C     *************
      VS1=SL(NYI)    
712   CONTINUE       
C
C SKUPINA: VLNA DOPADA SHORA A ODRAZI SE NAHORU
C
      IKSKUP=2
C
      VP2=VU(NYI+1)  
      VP2S=VU(NYI+1)
C     **************
      VS2=SU(NYI+1)  
      RO1=HN(NY+1)   
      RO2=HP(NY+1)   
      IF(JJ(I-1).GT.0)GO TO 135     
      IF(JJ(I).GT.0)GO TO 136 
C ODRAZ S SHORA NA S NAHORU
      NCODE=6  
      GO TO 137      
C ODRAZ S SHORA NA P NAHORU
  136 NCODE=5  
      RYRO=RYRO*VP1/VS1*SQRT(ABS((1.-(P*VP1)**2)/(1.-(P*VS1)**2)))      
      GO TO 137      
  135 IF(JJ(I).GT.0)GO TO 138 
C ODRAZ P SHORA NA S NAHORU
      NCODE=2  
      RYRO=RYRO*VS1/VP1*SQRT(ABS((1.-(P*VS1)**2)/(1.-(P*VP1)**2)))      
      GO TO 137      
C ODRAZ P SHORA NA P NAHORU
  138 NCODE=1  
  137 CONTINUE
C      IZNAM=-IZNAM   
      ND=1  
      IF(ABS(AO).LE.1.570796)ND=0      
      CALL COEF50(P,VP1,VS1,RO1,VP2,VS2,RO2,NCODE,ND,RMOD,RPH) 
      AMP=AMP*RMOD
      RAMP=RAMP*RMOD   
C
      IF(NCODE.EQ.1.OR.NCODE.EQ.5)RV1S=VP1S
C     *************************************
      IF(NCODE.EQ.1.OR.NCODE.EQ.5)RV1=VP1
      IF(NCODE.EQ.2.OR.NCODE.EQ.6)RV1=VS1
      DDA=DDE
      IF(P.LT..00001)ROZ=DDA/VZD    
      IF(P.GE..00001)ROZ=SQRT(ABS(DX/P/VZD*SQRT(ABS((1.-P**2*RV1**2)*(1
     /.-P**2*VZD**2)))*DDA/VZD))    
      TTSTAR=TSTAR*0.6366*ATAN(1.5923/FHZ)
      HAMP=AMP/ROZ
      HAMP=HAMP/EXP(3.1416*FHZ*TTSTAR)    
      HAMP=HAMP*SQRT(ABS(RYRO*VZD*ROZD/RV1/RO1))
C
      RADIR=RADS/EXP(H(NYI+1)/RADS)
C RADIR JE POLOMER DANE HRANICE
C Y0 JE EFA HLOUBKA ZDROJE, RADS JE ZDE VSUDE 6371 (NE RAD. SOURCE!!)
CC      IF(DX.LE..1)HAMP=HAMP/SQRT(EXP(YO/RADS))    
CC      IF(DX.GT..1)HAMP=HAMP/SQRT(EXP(YO/RADS)*ABS(SIN(ENTF/RADIR))*
CC     /RADIR/ENTF)
      IF(DX.LE..1)HAMP=HAMP/SQRT(EXP(YO/RADS)*(RADIR/RADS)**3)    
      IF(DX.GT..1)HAMP=HAMP/SQRT(EXP(YO/RADS)*ABS(SIN(ENTF/RADIR))*
     /RADIR/ENTF*(RADIR/RADS)**3)
C              RHAMP=ALOG10(HAMP)
C      STRAI=4.*HAMP*FHZ/RV1S
C           **             *
C              WRITE(7,*)COENTF,COH,RTIME,RHAMP,HAMP
C              WRITE(7,375)COENTF+RRXS*.00899322,COH,RTIME,STRAI,HAMP
              WRITE(7,375)COENTF+RRXS*.00899322,COH
CC              WRITE(*,*)HAMP,RHAMP
C
      PHA=PHA+RPH    
      IF(IABS(JJ(I-1)).EQ.NISG)K3=5
C
C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C ZASTAVENI VYPOCTU, KDYZ NECHCEME ODRAZENE VLNY
C
      IF(K3.EQ.5)STOP    
C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  134 GO TO 32       
   35 IF(DL1.LT.DL2)GO TO 104 
  103 IND=14      
      GO TO 76       
  104 IF(IABS(JJ(I)).GT.IABS(JJ(I-1))+1)GO TO 103     
      I1=IU(IS1)     
      I2=IL(IS1)     
      IF(K3.NE.2)GO TO 67     
      NY=IABS(JJ(I-1))     
      NYI=IU(IS1)    
      VP1=VL(NYI-1)  
      VP1S=VLS(NYI-1)
C     **************
      VS1=SL(NYI-1)  
      VP2=VU(NYI)    
      VP2S=VUS(NYI)
C     *************   
      VS2=SU(NYI)    
713   CONTINUE       
C
C SKUPINA LOM SHORA DOLU
C
      IKSKUP=3
C
      RO1=HN(NY+1)   
      RO2=HP(NY+1)   
      IF(JJ(I-1).GT.0)GO TO 130     
      IF(JJ(I).GT.0)GO TO 131 
C LOM S SHORA NA S DOLU
      NCODE=8  
      RYRO=RYRO*VS2*RO2/VS1/RO1*SQRT(ABS((1.-(P*VS2)**2)/(1.-(P*VS1)**2)
     /))    
      GO TO 132    
C LOM S SHORA NA P DOLU  
  131 NCODE=7  
      RYRO=RYRO*VP2*RO2/VS1/RO1*SQRT(ABS((1.-(P*VP2)**2)/(1.-(P*VS1)**2)
     /))  
      GO TO 132      
  130 IF(JJ(I).GT.0)GO TO 133 
C LOM P SHORA NA S DOLU
      NCODE=4  
      RYRO=RYRO*VS2*RO2/VP1/RO1*SQRT(ABS((1.-(P*VS2)**2)/(1.-(P*VP1)**2)
     /))  
      GO TO 132    
C LOM P SHORA NA P DOLU  
  133 NCODE=3  
      RYRO=RYRO*VP2*RO2/VP1/RO1*SQRT(ABS((1.-(P*VP2)**2)/(1.-(P*VP1)**2)
     /))  
  132 ND=1  
      IF(ABS(AO).LE.1.570796)ND=0      
      CALL COEF50(P,VP1,VS1,RO1,VP2,VS2,RO2,NCODE,ND,RMOD,RPH) 
      AMP=AMP*RMOD   
      RAMP=RAMP*RMOD   
C
      IF(NCODE.EQ.3.OR.NCODE.EQ.7)RV1=VP2
      RV1S=VP2S
C     ********
      IF(NCODE.EQ.4.OR.NCODE.EQ.8)RV1=VS2
      DDA=DDE
      IF(P.LT..00001)ROZ=DDA/VZD    
      IF(P.GE..00001)ROZ=SQRT(ABS(DX/P/VZD*SQRT(ABS((1.-P**2*RV1**2)*(1
     /.-P**2*VZD**2)))*DDA/VZD))    
      TTSTAR=TSTAR*0.6366*ATAN(1.5923/FHZ)
      HAMP=AMP/ROZ
      HAMP=HAMP/EXP(3.1416*FHZ*TTSTAR)    
      HAMP=HAMP*SQRT(ABS(RYRO*VZD*ROZD/RV1/RO2))
C
      RADIR=RADS/EXP(H(NYI+1)/RADS)
CC      IF(DX.LE..1)HAMP=HAMP/SQRT(EXP(YO/RADS))    
CC      IF(DX.GT..1)HAMP=HAMP/SQRT(EXP(YO/RADS)*ABS(SIN(ENTF/RADIR))*
CC     /RADIR/ENTF)
      IF(DX.LE..1)HAMP=HAMP/SQRT(EXP(YO/RADS)*(RADIR/RADS)**3)    
      IF(DX.GT..1)HAMP=HAMP/SQRT(EXP(YO/RADS)*ABS(SIN(ENTF/RADIR))*
     /RADIR/ENTF*(RADIR/RADS)**3)
C              RHAMP=ALOG10(HAMP)
C      STRAI=4.*HAMP*FHZ/RV1S
C                    **             *
C              WRITE(7,*)COENTF,COH,RTIME,RHAMP,HAMP
C              WRITE(7,375)COENTF+RRXS*.00899322,COH,RTIME,STRAI,HAMP
      WRITE(7,375)COENTF+RRXS*.00899322,COH
CC              WRITE(*,*)HAMP,RHAMP
C
      PHA=PHA+RPH    
   67 DL1=H(I1)      
      DL2=H(I2+1)    
      IG=IS1      
      GO TO 32       
   42 IF(DL1.LT.DL2)IND=14    
      IF(DL1.LT.DL2)GO TO 76  
      IF(IABS(JJ(I)).LT.IABS(JJ(I-1))-1)GO TO 103     
      I1=IU(IS2)     
      I2=IL(IS2)     
      IF(K3.NE.2)GO TO 145    
      NY=IABS(JJ(I-1))     
      NYI=IL(IS2)    
      VP1=VU(NYI+1)  
      VP1S=VUS(NYI+1)
C     ***************
      VS1=SU(NYI+1)  
      VP2=VL(NYI)    
      VP2S=VLS(NYI)
C     *************
714   CONTINUE       
C
C SKUPINA LOM ZDOLA NAHORU
C
      IKSKUP=4
C
      VS2=SL(NYI)    
      RO1=HP(NY)     
      RO2=HN(NY)     
      IF(JJ(I-1).GT.0)GO TO 146     
      IF(JJ(I).GT.0)GO TO 147 
C LOM S ZDOLA NA S NAHORU
      NCODE=8  
      RYRO=RYRO*VS2*RO2/VS1/RO1*SQRT(ABS((1.-(P*VS2)**2)/(1.-(P*VS1)**2)
     /))  
      GO TO 148       
C LOM S ZDOLA NA P NAHORU
  147 NCODE=7  
      RYRO=RYRO*VP2*RO2/VS1/RO1*SQRT(ABS((1.-(P*VP2)**2)/(1.-(P*VS1)**2)
     /))  
      GO TO 148      
  146 IF(JJ(I).GT.0)GO TO 149 
C LOM P ZDOLA NA S NAHORU
      NCODE=4  
      RYRO=RYRO*VS2*RO2/VP1/RO1*SQRT(ABS((1.-(P*VS2)**2)/(1.-(P*VP1)**2)
     /))  
      GO TO 148      
C LOM P ZDOLA NA P NAHORU
  149 NCODE=3  
      RYRO=RYRO*VP2*RO2/VP1/RO1*SQRT(ABS((1.-(P*VP2)**2)/(1.-(P*VP1)**2)
     /))  
  148 ND=0  
      IF(ABS(AO).LE.1.570796)ND=1      
      CALL COEF50(P,VP1,VS1,RO1,VP2,VS2,RO2,NCODE,ND,RMOD,RPH) 
      AMP=AMP*RMOD   
      RAMP=RAMP*RMOD   
C
      IF(NCODE.EQ.3.OR.NCODE.EQ.7)RV1=VP2
      RV1S=VP2S
C     *********
      IF(NCODE.EQ.4.OR.NCODE.EQ.8)RV1=VS2
      DDA=DDE
      IF(P.LT..00001)ROZ=DDA/VZD    
      IF(P.GE..00001)ROZ=SQRT(ABS(DX/P/VZD*SQRT(ABS((1.-P**2*RV1**2)*(1
     /.-P**2*VZD**2)))*DDA/VZD))    
      TTSTAR=TSTAR*0.6366*ATAN(1.5923/FHZ)
      HAMP=AMP/ROZ
      HAMP=HAMP/EXP(3.1416*FHZ*TTSTAR)    
      HAMP=HAMP*SQRT(ABS(RYRO*VZD*ROZD/RV1/RO2))
C
      RADIR=RADS/EXP(H(NYI+1)/RADS)
CC      IF(DX.LE..1)HAMP=HAMP/SQRT(EXP(YO/RADS))    
CC      IF(DX.GT..1)HAMP=HAMP/SQRT(EXP(YO/RADS)*ABS(SIN(ENTF/RADIR))*
CC     /RADIR/ENTF)
      IF(DX.LE..1)HAMP=HAMP/SQRT(EXP(YO/RADS)*(RADIR/RADS)**3)    
      IF(DX.GT..1)HAMP=HAMP/SQRT(EXP(YO/RADS)*ABS(SIN(ENTF/RADIR))*
     /RADIR/ENTF*(RADIR/RADS)**3)
C              RHAMP=ALOG10(HAMP)
C      STRAI=4.*HAMP*FHZ/RV1S
C                    **             *
C              WRITE(7,*)COENTF,COH,RTIME,RHAMP,HAMP
C              WRITE(7,375)COENTF+RRXS*.00899322,COH,RTIME,STRAI,HAMP
      WRITE(7,375)COENTF+RRXS*.00899322,COH
CC              WRITE(*,*)HAMP,RHAMP
C
      PHA=PHA+RPH    
  145 DL1=H(I2+1)    
      DL2=H(I1)      
      IG=IS2
32    CONTINUE
C
      IF(JJ(I).GT.0)CALL KINET(A,B,C,D,H,VU,VL,I1,I2,DL1,DL2,K3,P,DX,DT,
     /DDE,K1,HH,Z,A0,NDER,KROK,1,ENTF,RTIME,COENTF,COH)
      IF(JJ(I).LT.0)CALL KINET(AS,BS,CS,DS,H,SU,SL,I1,I2,DL1,DL2,K3,P,
     /DX,DT,DDE,K1,HH,Z,A0,NDER,KROK,2,ENTF,RTIME,COENTF,COH)      
C
      IF(K1.EQ.5)IND=19       
      IF(K1.EQ.5)GO TO 76     
      IF(K1.EQ.1.AND.JJ(I+1).NE.JJ(I))IND=20    
      IF(K1.EQ.3)IND=9     
715   CONTINUE       
      IF(K1.EQ.3)GO TO 76     
      IF(K1.EQ.1.AND.JJ(I+1).NE.JJ(I))GO TO 76  
      IF(K1.EQ.1)KS=1      
      IF(K1.EQ.1)GO TO 2      
      IF(DL1.LT.DL2)GO TO 110 
      IF((IG-1).LT.IS1)GO TO 2  
      IG=IG-1  
      I1=IU(IG)      
      I2=IL(IG)      
      DL1=DL2  
      DL2=H(I1)      
      GO TO 32       
  110 IF((IG+1).GT.IS2)GO TO 2 
      IG=IG+1  
      I1=IU(IG)      
      I2=IL(IG)      
      DL1=DL2  
      DL2=H(I2+1)    
      GO TO 32       
  111 IF(K3.NE.2)GO TO 14     
      IF(JJ(I-1).GT.0)V111=VU(1)    
      IF(JJ(I-1).LT.0)V111=SU(1)    
      DDA=DDE  
C      IF(DDE.LT.0.)IZNAM=-IZNAM     
      IF(P.LT..00001)ROZ=DDA/VZD    
      IF(P.GE..00001)ROZ=SQRT(ABS(DX/P/VZD*SQRT(ABS((1.-P**2*V111**2)*(1
     /.-P**2*VZD**2)))*DDA/VZD))    
      AMP=AMP/ROZ
C
C FOR Q=Q(FHZ) ONLY
      TTSTAR=TSTAR*0.6366*ATAN(1.5923/FHZ)
C
      AMP=AMP/EXP(3.1416*FHZ*TTSTAR)    
      AMP=AMP*SQRT(ABS(RYRO*VZD*ROZD/V111/HP(1)))     
      IF(KX.GT.0)GO TO 716    
      IF(DX.LE..1)AMP=AMP/SQRT(EXP(YO/RADS))    
      IF(DX.GT..1)AMP=AMP/SQRT(EXP(YO/RADS)*ABS(SIN(DX/RADS))*RADS/DX)
      POAMP=ALOG10(AMP)
CC        WRITE(7,*)POAMP
 716  CONTINUE
C  
      VP1=VU(1)      
      VS1=SU(1)      
      RO1=HP(1)      
      RO2=HN(1)      
      VP2=0.
      VS2=0.
      PU=P  
C
C SKUPINA KOEF.CONVERZE
C
      IKSKUP=5
C
C KONVERZE PRO PZ
      IF(JJ(I-1).GT.0)NCODE=6 
C KONVERZE PRO SZ
      IF(JJ(I-1).LT.0)NCODE=8 
      ND=0  
      IF(ABS(AO).LE.1.570796)ND=1      
      CALL COEF50(PU,VP1,VS1,RO1,VP2,VS2,RO2,NCODE,ND,RMOD,RPH)   
C
717   CONTINUE 
      AMPZ=AMP*RMOD  
C
C  VYTISKNEME DO OUT AMPZ A LOG(AMPZ), STEJNE TAK I AMPX A LOG(AMPX)
C  TAKZE TAM BUDOU FIGUROVAT SPOLU S NORMALNIM VYSTUPEM ALA ZESY
C  HODNOTY LOGARITMU JSOU NUTNE, ABY SE DALO Z POZOROVANE ZLOZKY
C  NA POVRCHU (OPRAVENE NA SEISMOGRAF) PREJIT NA TOTALNI AMPLITUDU
C  TESNE POD POVRCHEM PROSTREDI A PAK ZPET PO PAPRSKU, PROTOZE PO 
C  PAPRSKU TO TRASUJEME V LOGARITMU (ABY NEBYL TAK VELKY ROZSAH ZMENY)
C 
C      POAMPZ=ALOG10(AMPZ)
C      STRAI=4.*AMPZ*FHZ/VU(1)
C           **
CCCCC      WRITE(6,*)AMPZ,POAMPZ      
C  ZKUSIT VYTISKNOUT Z SLOZKU POKUSNE I DO VYSTUPU (7,*) ?????????????
C      WRITE(7,*)COENTF,COH,RTIME,POAMPZ,AMPZ
C      WRITE(7,375)COENTF+RRXS*.00899322,COH,RTIME,STRAI,AMPZ
      WRITE(7,375)COENTF+RRXS*.00899322,COH
C
C VYTISNOUT 9000 PRO CLIPING
      DEVET=9000.
C      WRITE(7,*)DEVET,DEVET,DEVET,DEVET,DEVET
      WRITE(7,*)DEVET,DEVET
C
      PHAZ=PHA+RPH+FLOAT(NDER)*1.5708   
C      IF(IZNAM.GT.0)PHAZ=PHAZ+1.5708   
C KONVERZE PRO PX
      IF(JJ(I-1).GT.0)NCODE=5 
C KONVERZE PRO SX
      IF(JJ(I-1).LT.0)NCODE=7 
      CALL COEF50(PU,VP1,VS1,RO1,VP2,VS2,RO2,NCODE,ND,RMOD,RPH)   
      AMPX=AMP*RMOD  
C
      POAMPX=ALOG10(AMPX)
CCCCC      WRITE(6,*)AMPX,AMPX,POAMPX
C
      PHAX=PHA+RPH+FLOAT(NDER)*1.5708   
C      IF(IZNAM.GT.0)PHAX=PHAX+1.5708   
   14 IND=3 
   76 IF(IND.NE.3)GO TO 94    
      TO=TO+DT       
      IF(ABS(AO).GT.1.570796)XO=XO-DX  
      IF(ABS(AO).LE.1.570796)XO=XO+DX  
      IF(K3.NE.2)AMPX=0.      
      IF(K3.NE.2)AMPZ=0.      
      IF(K3.NE.2)PHAX=0.      
      IF(K3.NE.2)PHAZ=0.      
   94 CONTINUE       
      RETURN      
      END   
C
C   
      SUBROUTINE SPLINE (X,Y,DY,A,B,C,D,H,R0,R1,R2,C0,C1,N)      
      DIMENSION H(99),R0(99),R1(99),R2(99),C0(99),C1(99),D(      
     /99),C(99),B(99),A(99),X(99),Y(99),DY(99)      
      ITMAX=50
      P=0.              
      PP=0.             
      N11=N-1           
      DO 1 I=1,N11            
    1 H(I)=X(I+1)-X(I)        
      A(1)=Y(2)         
      B(1)=(Y(1)-Y(2))/H(1)         
      C(1)=0.           
      D(1)=0.           
      IF(N.EQ.2)GO TO 12            
      N1=N11-1          
C CONSTRUCTION OF THE MATRIX R AND OF THE VECTOR H(T)Y      
      DO 2 I=1,N1             
      A(I)=(Y(I)-Y(I+1))/H(I)-(Y(I+1)-Y(I+2))/H(I+1)        
      B(I)=DY(I+1)*(1./H(I)+1./H(I+1))          
      C(I)=-DY(I)/H(I)        
    2 D(I)=-DY(I+2)/H(I+1)          
      POM=C(1)**2+B(1)**2+D(1)**2         
      R1(1)=0.          
      DO 3 I=1,N1             
      R0(I)=B(I)*B(I)+C(I)*C(I)+D(I)*D(I)       
      IF(I.GE.3) R2(I)=DY(I)*DY(I)/H(I-1)/H(I)        
    3 IF(I.NE.1) R1(I)=D(I-1)*B(I)+B(I-1)*C(I)        
      DO 10 ITER=1,ITMAX            
      DO 4 I=1,N1             
      R0(I)=R0(I)+(P-PP)*2.*(H(I)+H(I+1))/3.    
    4 R1(I)=R1(I)+(P-PP)*H(I)/3.          
C DECOMPOSITION OF THE MATRIX R AND SOLUTION OF THE SYSTEM RU=H(T)Y     
      C(1)=A(1)/R0(1)         
      C(2)=0.           
      E=C(1)*C(1)*POM         
      B(1)=C(1)*DY(2)*(1./H(1)+1./H(2))         
      IF(N.EQ.3)GO TO 13            
      CALL DECOMP(R0,R1,R2,C0,C1,N1)      
      CALL SOL(C0,C1,R2,C,A,N1)           
C CALCULATION OF THE VECTOR V       
      B(1)=DY(2)*((1./H(1)+1./H(2))*C(1)-C(2)/H(2))   
      E=B(1)*B(1)             
      C(N11)=0.         
      DO 5 I=2,N1             
      B(I)=DY(I+1)*(C(I)*(1./H(I)+1./H(I+1))-C(I+1)/H(I+1)-C(I-1)/H(I)) 
      D(I)=(H(I)*C(I-1)+2.*(H(I)+H(I+1))*C(I)+H(I+1)*C(I+1))/3.   
    5 E=E+B(I)*B(I)           
      E=E+(C(N1)*DY(N)/H(N11))**2+(C(1)*DY(1)/H(1))**2      
   13 F=FLOAT(N)+1.E-4        
C TEST WHETHER E.LE.EPS OR WHETHER THE NUMBER OF ITERATIONS IS HIGH     
      IF(E.LE.F.OR.ITER.EQ.ITMAX)GO TO 11       
C CALCULATION OF THE NEXT ITERATION OF P        
      D(1)=(2.*(H(1)+H(2))*C(1)+H(2)*C(2))/3.         
      B(1)=D(1)/R0(1)         
      IF(N.EQ.3)GO TO 14            
      CALL SOL(C0,C1,R2,B,D,N1)           
   14 G=0.              
      F=0.              
      DO 6 I=1,N1             
      G=G+B(I)*D(I)           
    6 F=F+C(I)*D(I)           
      PP=P              
      RA=N              
      P=P-(E-RA)/(P*G-F)/2.         
   10 CONTINUE          
C CALCULATION OF THE SPLINE COEFFICIENTS        
   11 A(N11)=-DY(N)*DY(N)*C(N1)/H(N11)+Y(N)     
      DO 7 I=1,N1             
      A(I)=DY(I+1)*B(I)+Y(I+1)      
    7 C(I)=P*C(I)             
      D(1)=-C(1)/H(1)/3.            
      B(1)=(A(1)-A(2))/H(2)         
      IF(P.NE.0.) B(1)=-C(1)*(DY(1)*DY(1)/P/H(1)/H(1)+2.*H(1)/3.)-(A(1)-
     /Y(1))/H(1)     
      DO 8 I=2,N11         
      D(I)=(C(I-1)-C(I))/3./H(I)       
    8 B(I)=B(I-1)-H(I)*(C(I-1)+C(I))   
C CALCULATION OF DERIVATIVES IN THE KNOT POINTS    
   12 G=H(1)         
      R0(1)=((D(1)*G+C(1))*G+B(1))*G+A(1)    
      R1(1)=-(3.*D(1)*G+2.*C(1))*G-B(1)      
      R2(1)=6.*D(1)*G+2.*C(1)    
      A(N)=R0(1)     
      B(N)=R1(1)     
      DO 9 I=2,N     
      R0(I)=A(I-1)         
      R2(I)=C(I-1)         
      R1(I)=-B(I-1)        
      C0(I)=-6.*D(I)       
    9 C1(I-1)=C0(I)        
      RETURN         
      END      
      SUBROUTINE DECOMP (A0,A1,A2,C0,C1,N)      
      DIMENSION A0(99),A1(99),A2(99),C0(99),C1(99) 
      C0(1)=A0(1)             
      C1(2)=A1(2)             
      C0(2)=A0(2)-C1(2)*C1(2)/C0(1)       
      DO 1 I=3,N        
      C1(I)=A1(I)-A2(I)*C1(I-1)/C0(I-2)         
    1 C0(I)=A0(I)-C1(I)*C1(I)/C0(I-1)-A2(I)*A2(I)/C0(I-2)   
      RETURN            
      END         
      SUBROUTINE SOL (C0,C1,C2,X,Y,N)     
      DIMENSION C0(99),C1(99),C2(99),X(99),Y(99)
      X(1)=Y(1)/C0(1)         
      X(2)=(Y(2)-C1(2)*X(1))/C0(2)        
      DO 1 I=3,N        
    1 X(I)=(Y(I)-C2(I)*X(I-2)-C1(I)*X(I-1))/C0(I)     
      X(N-1)=X(N-1)-C1(N)/C0(N-1)*X(N)          
      IF(N.EQ.2)GO TO 3       
      DO 2 J=3,N        
      I=N-J+1           
    2 X(I)=X(I)-C1(I+1)/C0(I)*X(I+1)-C2(I+2)/C0(I)*X(I+2)   
    3 CONTINUE          
      RETURN            
      END 
C
C        
      SUBROUTINE COEF50(P,VP1,VS1,RO1,VP2,VS2,RO2,NCODE,ND,RMOD,RPH)    
      COMPLEX B(4),RR,C1,C2,C3,C4,H1,H2,H3,H4,H5,H6,H,HB,HC       
      DIMENSION PRMT(4),D(4),DD(4)        
      PRMT(1)=VP1             
      PRMT(2)=VS1             
      PRMT(3)=VP2             
      PRMT(4)=VS2             
      A1=VP1*VS1        
      A2=VP2*VS2        
      A3=VP1*RO1        
      A4=VP2*RO2        
      A5=VS1*RO1        
      A6=VS2*RO2        
      IF(RO2.LT.0.000001)GO TO 150        
      Q=2.*(A6*VS2-A5*VS1)          
      PP=P*P            
      QP=Q*PP           
      X=RO2-QP          
      Y=RO1+QP         
      Z=RO2-RO1-QP            
      G1=A1*A2*PP*Z*Z         
      G2=A2*X*X         
      G3=A1*Y*Y         
      G4=A4*A5          
      G5=A3*A6          
      G6=Q*Q*PP         
      DO 21 I=1,4             
      DD(I)=P*PRMT(I)         
   21 D(I)=SQRT(ABS(1.-DD(I)*DD(I)))      
      IF(DD(1).LE.1..AND.DD(2).LE.1..AND.DD(3).LE.1..AND.DD(4).LE.1.)   
     1GO TO 100         
C           
C     COMPLEX COEFFICIENTS          
      DO 22 I=1,4             
      IF(DD(I).GT.1.)GO TO 23       
      B(I)=CMPLX(D(I),0.)           
      GO TO 22          
   23 B(I)=-CMPLX(0.,D(I))          
   22 CONTINUE          
      C1=B(1)*B(2)            
      C2=B(3)*B(4)            
      C3=B(1)*B(4)            
      C4=B(2)*B(3)            
      H1=G1             
      H2=G2*C1          
      H3=G3*C2          
      H4=G4*C3          
      H5=G5*C4          
      H6=G6*C1*C2             
      H=1./(H1+H2+H3+H4+H5+H6)      
      HB=2.*H           
      HC=HB*P           
      GO TO (1,2,3,4,5,6,7,8),NCODE       
    1 RR=H*(H2+H4+H6-H1-H3-H5)      
      GO TO 26          
    2 RR=VP1*B(1)*HC*(Q*Y*C2+A2*X*Z)      
      IF(ND.NE.0)RR=-RR       
      GO TO 26          
    3 RR=A3*B(1)*HB*(VS2*B(2)*X+VS1*B(4)*Y)     
      GO TO 26          
    4 RR=-A3*B(1)*HC*(Q*C4-VS1*VP2*Z)     
      IF(ND.NE.0)RR=-RR       
      GO TO 26          
    5 RR=-VS1*B(2)*HC*(Q*Y*C2+A2*X*Z)     
      IF(ND.NE.0)RR=-RR       
      GO TO 26          
    6 RR=H*(H2+H5+H6-H1-H3-H4)      
      GO TO 26          
    7 RR=A5*B(2)*HC*(Q*C3-VP1*VS2*Z)      
      IF(ND.NE.0)RR=-RR       
      GO TO 26          
    8 RR=A5*B(2)*HB*(VP1*B(3)*Y+VP2*B(1)*X)     
      GO TO 26          
C     REAL COEFFICIENTS       
  100 E1=D(1)*D(2)            
      E2=D(3)*D(4)            
      E3=D(1)*D(4)            
      E4=D(2)*D(3)            
      S1=G1             
      S2=G2*E1          
      S3=G3*E2          
      S4=G4*E3          
      S5=G5*E4          
      S6=G6*E1*E2             
      S=1./(S1+S2+S3+S4+S5+S6)      
      SB=2.*S           
      SC=SB*P           
      GO TO (101,102,103,104,105,106,107,108),NCODE   
  101 R=S*(S2+S4+S6-S1-S3-S5)       
      GO TO 250         
  102 R=VP1*D(1)*SC*(Q*Y*E2+A2*X*Z)       
      IF(ND.NE.0)R=-R         
      GO TO 250         
  103 R=A3*D(1)*SB*(VS2*D(2)*X+VS1*D(4)*Y)      
      GO TO 250         
  104 R=-A3*D(1)*SC*(Q*E4-VS1*VP2*Z)      
      IF(ND.NE.0)R=-R         
      GO TO 250         
  105 R=-VS1*D(2)*SC*(Q*Y*E2+A2*X*Z)      
      IF(ND.NE.0)R=-R         
      GO TO 250         
  106 R=S*(S2+S5+S6-S1-S3-S4)       
      GO TO 250         
  107 R=A5*D(2)*SC*(Q*E3-VP1*VS2*Z)       
      IF(ND.NE.0)R=-R         
      GO TO 250         
  108 R=A5*D(2)*SB*(VP1*D(3)*Y+VP2*D(1)*X)      
      GO TO 250         
C           
C     EARTHS SURFACE,COMPLEX COEFFICIENTS AND COEFFICIENTS OF CONVERSION
  150 A1=VS1*P          
      A2=A1*A1          
      A3=2.*A2          
      A4=2.*A1          
      A5=A4+A4          
      A6=1.-A3          
      A7=2.*A6          
      A8=2.*A3*VS1/VP1        
      A9=A6*A6          
      DD(1)=P*VP1             
      DD(2)=P*VS1             
      DO 151 I=1,2            
  151 D(I)=SQRT(ABS(1.-DD(I)*DD(I)))      
      IF(DD(1).LE.1..AND.DD(2).LE.1.)GO TO 200        
      DO 154 I=1,2            
      IF(DD(I).GT.1.)GO TO 155      
      B(I)=CMPLX(D(I),0.)           
      GO TO 154         
  155 B(I)=-CMPLX(0.,D(I))          
  154 CONTINUE          
      H1=B(1)*B(2)            
      H2=H1*A8          
      H=1./(A9+H2)            
      GO TO (161,162,163,164,165,166,167,168),NCODE   
  161 RR=(-A9+H2)*H           
      GO TO 26          
  162 RR=-A5*B(1)*H*A6        
      IF(ND.NE.0)RR=-RR       
      GO TO 26          
  163 RR=A5*B(2)*H*A6*VS1/VP1       
      IF(ND.NE.0)RR=-RR       
      GO TO 26          
  164 RR=-(A9-H2)*H           
      GO TO 26          
  165 RR=-A5*H1*H             
      IF(ND.NE.0)RR=-RR       
      GO TO 26          
  166 RR=A7*B(1)*H            
      GO TO 26          
  167 RR=-A7*B(2)*H           
      GO TO 26          
  168 RR=-A5*VS1*H1*H/VP1           
      IF(ND.NE.0)RR=-RR       
   26 Z2=REAL(RR)             
      Z3=AIMAG(RR)            
      IF(Z2.EQ.0..AND.Z3.EQ.0.)GO TO 157        
      RMOD=SQRT(Z2*Z2+Z3*Z3)        
      RPH=ATAN2(Z3,Z2)        
      RETURN            
  157 RMOD=0.           
      RPH=0.            
      RETURN            
C           
C     EARTHS SURFACE,REAL COEFFICIENTS AND COEFFICIENTS OF CONVERSION   
  200 S1=D(1)*D(2)            
      S2=A8*S1          
      S=1./(A9+S2)            
      GO TO (201,202,203,204,205,206,207,208),NCODE   
  201 R=(-A9+S2)*S            
      GO TO 250         
  202 R=-A5*D(1)*S*A6         
      IF(ND.NE.0)R=-R         
      GO TO 250         
  203 R=A5*D(2)*S*A6*VS1/VP1        
      IF(ND.NE.0)R=-R         
      GO TO 250         
  204 R=(S2-A9)*S             
      GO TO 250         
  205 R=-A5*S1*S        
      IF(ND.NE.0)R=-R         
      GO TO 250         
  206 R=A7*D(1)*S             
      GO TO 250         
  207 R=-A7*D(2)*S            
      GO TO 250         
  208 R=-A5*VS1*S1*S/VP1            
      IF(ND.NE.0)R=-R         
  250 IF(R.LT.0.)GO TO 251          
      RMOD=R            
      RPH=0.            
      RETURN            
  251 RMOD=-R           
      RPH=3.14159             
      RETURN            
      END         
C
C
      SUBROUTINE SOURCE(MPRINT,MWAVE,MTYPE,ANGLE,AMSOUR,PHSOUR)     
      DIMENSION PPAR(4),T(3,3),V1(3),V2(3)        
      COMMON/SOUR/ROS,VPS,VSS,MPSOUR        
      SAVE PPAR
      PI=4.*ATAN(1.)            
      IF(MWAVE.NE.0)GO TO 1           
      READ(5,*)PPAR           
      WRITE(6,200)PPAR          
      GO TO 36            
    1 AMSOUR=1.           
      PHSOUR=0.           
      IF(MTYPE.NE.7)RETURN            
   36 CONTINUE            
      SM=PPAR(2)
      FS=PPAR(3)          
      D=PPAR(1)           
      AL=PPAR(4)          
      SNF=SIN(FS)         
      CSF=COS(FS)         
      SND=SIN(D)          
      CSD=COS(D)          
      SNL=SIN(AL)         
      CSL=COS(AL)         
      A=CSL*CSF+CSD*SNL*SNF           
      B=CSL*SNF-CSD*SNL*CSF           
      C=SNF*SND           
      D=SNL*SND           
      T(1,1)=-2.*A*C            
      T(1,2)=2.*SND*(A*CSF-.5*CSL)          
      T(2,1)=T(1,2)             
      T(1,3)=-(A*CSD-C*D)             
      T(3,1)=T(1,3)             
      T(2,2)=2.*SND*(A*SNF-CSD*SNL)         
      T(2,3)=-(B*CSD+D*SND*CSF)       
      T(3,2)=T(2,3)             
      T(3,3)=2.*D*CSD           
      IF(MWAVE.NE.0)GO TO 19          
      IF(MPRINT.GE.1)WRITE(6,102)T          
      RETURN              
C             
   19 V1(1)=COS(ANGLE)          
      V1(2)=0.            
CC
CC FOR THE CASE OF AZIMUTH, SEE VERSION JZD: AZ IN FORMAL DATA
CC     19 AZ=303.*PI/180.
CC        V1(1)=COS(ANGLE)*COS(AZ)          
CC        V1(2)=COS(ANGLE)*SIN(AZ)
      V1(3)=SIN(ANGLE)          
      AUX1=SM/(4.*PI*ROS)             
      AUXP=AUX1/(VPS*VPS*VPS)         
      AUXS=AUX1/(VSS*VSS*VSS)         
      IF(MWAVE.GE.2)GO TO 21          
C             
C     P WAVE              
      AMSOUR=0.           
      DO 22 I=1,3         
      DO 22 J=1,3         
      AMSOUR=AMSOUR+V1(I)*T(I,J)*V1(J)      
   22 CONTINUE            
      AMSOUR=AUXP*AMSOUR        
      GO TO 51            
C             
C     SV WAVE             
   21 IF(MWAVE.EQ.3)GO TO 24          
      V2(1)=SIN(ANGLE)          
      V2(2)=0.            
      V2(3)=-COS(ANGLE)         
      AMSOUR=0.           
      DO 23 I=1,3         
      DO 23 J=1,3         
      AMSOUR=AMSOUR+V2(I)*T(I,J)*V1(J)      
   23 CONTINUE            
      AMSOUR=AUXS*AMSOUR        
      GO TO 51            
C             
C     SH WAVE             
   24 AMSOUR=AUXS*(T(1,2)*V1(1)+T(2,3)*V1(3))     
      GO TO 51            
C             
   51 PHSOUR=0.           
   50 IF(AMSOUR)52,53,53        
   52 AMSOUR=-AMSOUR            
      PHSOUR=PHSOUR-PI          
  102 FORMAT(/2X,/(3E15.5))          
  200 FORMAT(/' DIP MOMENT STRIKE RAKE'/2X,6E12.5)         
   53 RETURN              
      END
C
C
      SUBROUTINE KINET(A,B,C,D,H,VU,VL,I1,I2,DL1,DL2,K,P,DX,DT,DD,K1,HH,  
     /Z,AO,NDER,KROK,LQ,ENTF,RTIME,COENTF,COH)
C PRENOS ENTF Z MRAY, TAM NULOVAN, 
C TRASOVANI PAPRSKU TEPRVE PO VYITEROVANI VZDAL.
      CHARACTER*8 IPHA
      DIMENSION A(99),B(99),C(99),D(99),H(99),VU(99),VL(99),
     /HH(99),QF(99),E(99),EE(99),VUS(99),VLS(99)
C                                ***************
      COMMON/OPR/QF,TSTAR,FHZ,NSLO,MWAVE,RAMP,IKSKUP,RZSOUR,RVZD,RROZD,
     /RVAL,RYRO,E,EE
      COMMON/SPHER/VUS,VLS,RVZDS
      COMMON/RR/RRXS,RRZS,RRTS,RRTA
	SAVE POL,ENTF1,RTIME1,RVAL1
C     ********************
      KS=0     
      IF(K1.EQ.1)KS=1      
      RADS=6371.
C
C PROZATIMNE
C
      K1=0     
      P2=P*P   
      P3=P2*P  
      P4=P3*P  
      P6=P4*P2 
718   CONTINUE 
C      
      DDX=0    
      DDT=0    
      DDD=0    
      VAL=0
      IF(DL1.GT.DL2)GO TO 10     
      IF(I1.EQ.I2.AND.ABS(VU(I1)-VL(I1))/(HH(I1+1)-HH(I1)).LT..000002)  
     /GO TO 29  
      IF(ABS(DL1-H(I1)).LT..002)GO TO 11
      J=I1-1   
   12 J=J+1    
      IF(H(J+1).LE.DL1)GO TO 12  
      V1=1./P
      IF(KS.EQ.1.AND.J.EQ.I2)V2=VL(J)  
      IF(KS.EQ.1)GO TO 17  
      IF(NSLO.NE.2)GO TO 15      
      IF(VU(J).LT.VL(J))GO TO 23 
      IF(J.EQ.I2)V2=VL(J)
      GO TO 17 
   23 Z=DL1    
      K1=1     
      GO TO 18 
   15 K2=0     
      GO TO 24 
   11 J=I1     
   14 V1=VU(J) 
   13 V2=VL(J) 
      IF(P*V1.GT..99999 )K1=3    
      IF(K1.EQ.3)GO TO 18  
      IF(P*VL(J).LT..99999 )GO TO 17   
      IF(P*VL(J).LT.1.00001)K1=5 
      IF(K1.EQ.5)GO TO 18  
      Z=A(J)+B(J)*P2+C(J)*P4+D(J)*P6   
      K1=1     
      GO TO 17 
   10 IF(I1.EQ.I2.AND.ABS(VU(I1)-VL(I1))/(HH(I1+1)-HH(I1)).LT..000002)  
     /GO TO 30  
      IF(ABS(DL1-H(I2+1)).LT..002)GO TO 1    
      J=I2+1   
    2 J=J-1    
      IF(H(J).GE.DL1)GO TO 2     
      V1=1./P
      IF(KS.EQ.1.AND.J.EQ.I1)V2=VU(J)  
      IF(KS.EQ.1)GO TO 17  
      IF(NSLO.NE.2)GO TO 21      
      IF(VL(J).LT.VU(J))GO TO 25 
      IF(J.EQ.I1)V2=VU(J)
      GO TO 17 
   25 Z=DL1  
      K1=1     
      GO TO 18 
   21 K2=2     
      GO TO 24 
    1 J=I2     
    4 V1=VL(J) 
    3 V2=VU(J) 
      IF(P*V1.GT..99999 )K1=3    
      IF(K1.EQ.3)GO TO 18  
      IF(P*VU(J).LT..99999 )GO TO 17   
      IF(P*VU(J).LT.1.00001)K1=5 
      IF(K1.EQ.5)GO TO 18  
      Z=A(J)+B(J)*P2+C(J)*P4+D(J)*P6   
      K1=1     
      GO TO 17 
   24 VN=VU(J) 
      VD=VL(J) 
      HN=H(J)  
      HD=H(J+1)      
      ZZ=DL1   
   31 V=VN+(ZZ-HN)*(VD-VN)/(HD-HN)     
      FV=A(J)+B(J)/V**2+C(J)/V**4+D(J)/V**6  
      IF(ABS(FV-ZZ).LT..05)GO TO 32   
      IF(FV.GT.ZZ)GO TO 33 
      VN=V     
      HN=FV    
      GO TO 31 
   33 VD=V     
      HD=FV    
      GO TO 31 
   32 V1=V     
      IF(K2.EQ.0)GO TO 13  
      IF(K2.EQ.2)GO TO 3   
   17 VV=V1     
      U=SQRT(ABS(1./VV**2-P**2)) 
      KROK=KROK+1    
      Q1=2.*B(J)+4.*C(J)*P2+6.*D(J)*P4 
      Q2=4./3.*C(J)*P+4.*D(J)*P3 
      Q3=6./5.*D(J)  
      IF(P*V1.GT..99999)GO TO 8  
      U3=U**3  
      U5=U**5  
      XD=U*Q1*P+U3*Q2+Q3*P*U5    
C  USEK Z PRVNIHO BODU AZ DO FALESNEHO MINIMA     
C
      DDX=DDX-XD     
719   CONTINUE 
      IF(K.EQ.0)GO TO 7    
      U7=U**7  
      TD=U*Q1*P2+(2./3.*B(J)+8./3.*C(J)*P2+6.*D(J)*P4)*U3+(4./5.*C(J)+18  
     /./5.*D(J)*P2)*U5+6./7.*D(J)*U7   
      VAL=VAL-TD/QF(J)
      DDT=DDT-TD     
CC      IF(K.EQ.1)GO TO 7    
      D1=-P2/U*Q1+U*(2.*B(J)+8.*C(J)*P2+18.*D(J)*P4)+U3*(4./3.*C(J)+6.*D  
     /(J)*P2)+Q3*U5  
      IF(DL1.GT.DL2)D1=-D1 
      ENTF1=XD
      RTIME1=TD
      RVAL1=TD/QF(J)
      POMDD=DD
      DD=DD-D1 
    7 IF(K1.NE.1)GO TO 8   
C
C MINIMUM NEBUDE FALESNE, PROTO VEZMEME CELY VYSLEDEK A NAVIC HO PAK
C PRIPOCITAME JESTE JEDNOU, ABY BYL VZAT I PRISPEVEK Z MINIMA NAHORU
C
      IF(K.EQ.0)GO TO 400
C
      ENTF=ENTF+ABS(ENTF1)
      RTIME=RTIME+ABS(RTIME1)
      RVAL=RVAL+ABS(RVAL1)
C
      HHH=Z
C PROZATIMNE
C JE NUTNO UPRAVIT: RYCHLOST V MINIMU BY SE DALA ZISKAT Z HODNOTY
C P=1/V A NEBO EVENT. LIN. INTERPOLACI Z HODNOT RYCHLOSTI A HLOUBEK 
C NAHORE  DOLE A Z HLOUBKY MINIMA,
C HUSTOTA ASI JEN INTERPOLACI
C
C POKUS UDELAT TO LIN. INTERPOLACI NEBO Z P=1/V DAVALO JESTE PODSTATNE
C HORSI VYSLEDKY. JEDIOU CESTOU, KTERA ALE NEDAVA RADOVE MENSI
C OSCILACE A TROCHU KRIVKY "VYBOULUJE" JE SPOJENI HODNOT AMPLITUD
C PRO BOD OB JEDEN PRED MINIMEM A OB JEDEN ZA MINIMEM A ODECTENI
C APLITUD PRO BOD JEDEN PRED MINIMEM, MINIMUM A JEDEN ZA MINIMEM
C Z TETO SPOJNICE. VIZ PROGRAM "VYHLAZ".
C
C!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
C           RATIO=(HHH-HH(J))/(HH(J+1)-HH(J))
C           RV1=VU(J)+RATIO*(VL(J)-VU(J))
C           RRO=E(J)+RATIO*(EE(J)-E(J))
      RV1=VU(J)
      RV1S=VUS(J)
C     ***********
      RRO=.5*(E(J)+EE(J))
C
      ADD=POMDD
      IF(ABS(DD).GT.ABS(POMDD))ADD=DD
C
      IF(P.LT..00001)ROZ=ABS(ADD/RVZD)
      IF(P.GE..00001)ROZ=SQRT(ABS(ENTF/P/RVZD*SQRT
     /(ABS((1.-P**2*RV1**2)*(1.-P**2*RVZD**2)))*ADD/RVZD))    
      TTSTAR=RVAL*0.6366*ATAN(1.5923/FHZ)
      RRAMP=RAMP/ROZ
      RRAMP=RRAMP/EXP(3.1416*FHZ*TTSTAR)    
C      RRAMP=RRAMP*SQRT(ABS(RYRO*RVZD*RROZD/RV1/RRO))
C
      RRADI=RADS/EXP(HHH/RADS)
C
C NASLEDUJE PUVODNI VZOREC (NEUPLNY) PRO N=0
CC      IF(ENTF.LE..1)RRAMP=RRAMP/SQRT(EXP(RZSOUR/RADS))    
CC      IF(ENTF.GT..1)RRAMP=RRAMP/SQRT(EXP(RZSOUR/RADS)*ABS(SIN(ENTF/
CC     /RRADI))*RRADI/ENTF)
C NASLEDUJE VZOREC PRO N=-1, ALE HUSTOTY NEBYLY UPRAVENY, AC TOTO
C N TO VYZADUJE
CC      IF(ENTF.LE..1)RRAMP=RRAMP*RADS/RRADI    
CC      IF(ENTF.GT..1)RRAMP=RRAMP*RADS/RRADI*SQRT(1./ABS(SIN(ENTF/
CC     /RRADI))/RRADI*ENTF)
C SPRAVNY (UPLNY) VZOREC PRO N=0
      IF(ENTF.LE..1)RRAMP=RRAMP/SQRT(EXP(RZSOUR/RADS)*(RRADI/RADS)**3)    
      IF(ENTF.GT..1)RRAMP=RRAMP/SQRT(EXP(RZSOUR/RADS)*ABS(SIN(ENTF/
     /RRADI))*RRADI/ENTF*(RRADI/RADS)**3)
C
C VYPOCET DALSICH HODNOT A TISK HODNOT PRO BOD MINIMA
C
      COH=6371.*(1.-1./EXP(HHH/6371.))
      COENTF=ENTF/6371.*180./3.1415926
C           ARRAMP=ALOG10(RRAMP)
C      STRAIN=4.*RRAMP/RV1S*FHZ
C            **          *
C           WRITE(7,*)COENTF,COH,RTIME,ARRAMP,RRAMP
C
C ZDE SE BUD TISKNE NEBO NETISKNE HODNOTA V MINIMU
C           WRITE(7,375)COENTF,COH,RTIME,STRAIN,RRAMP
      WRITE(7,375)COENTF+RRXS*.00899322,COH
C
      VYS1=SQRT(ABS(SIN(ENTF/RRADI)*RRADI/ENTF))
      VYS2=SQRT(ABS(SIN(ENTF/RADS)*RADS/ENTF))
CC          WRITE(*,*)COH,RRADI,VYS1,VYS2
C
C PRICTEME JESTE JEDNOU, PRO USEK Z MINIMA NAHORU, DO NEJBLIZSIHO
C GRID BODU
C
      ENTF=ENTF+ABS(ENTF1)            
      RTIME=RTIME+ABS(RTIME1)
      RVAL=RVAL+ABS(RVAL1)
  400 CONTINUE
C
      IF(K.NE.2)GO TO 22   
      IF(KROK.EQ.1)POL=1.  
      GO TO 22 
    8 V2=VL(J) 
      IF(DL1.GT.DL2)V2=VU(J)     
      VV=V2    
      U=SQRT(ABS(1./VV**2-P**2)) 
      U3=U**3  
      U5=U**5  
      XD=U*Q1*P+U3*Q2+Q3*P*U5    
      DDX=DDX+XD     
      IF(K.EQ.0)GO TO 20   
      U7=U**7  
721   CONTINUE 
      TD=U*Q1*P2+(2./3.*B(J)+8./3.*C(J)*P2+6.*D(J)*P4)*U3+(4./5.*C(J)+18  
     /./5.*D(J)*P2)*U5+6./7.*D(J)*U7   
      VAL=VAL+TD/QF(J)
      DDT=DDT+TD     
CC      IF(K.EQ.1)GO TO 20   
      D1=-P2/U*Q1+U*(2.*B(J)+8.*C(J)*P2+18.*D(J)*P4)+U3*(4./3.*C(J)+6.*D  
     /(J)*P2)+Q3*U5  
      IF(DL1.GT.DL2)D1=-D1 
      DD=DD+D1 
C
C SPOCTEME PRISPEVEK OD DRUHEHO BODU AZ DO FALESNEHO MINIMA
C A PRISPEVKY OD PRVNIHO A DRUHEHO BODU OD SEBE ODECTEME
C TIM ZISKAME PRISPEVEK OD USEKU, KDE NENI MINIMUM
C
      IF(K.EQ.0)GO TO 401
C
      ENTF2=XD
      RTIME2=TD
      RVAL2=TD/QF(J)
C
      IF(DL1.LT.DL2)HHH=H(J+1)
      IF(DL1.GT.DL2)HHH=H(J)
      IF(DL1.LT.DL2)RV1=VL(J)
      IF(DL1.LT.DL2)RV1S=VLS(J)
C        *************************
      IF(DL1.GT.DL2)RV1=VU(J)
      IF(DL1.GT.DL2)RV1S=VUS(J)
C        *************************
      IF(DL1.LT.DL2)RRO=EE(J)
      IF(DL1.GT.DL2)RRO=E(J)
C
      ENTF=ENTF+ABS(ENTF1-ENTF2)
      RTIME=RTIME+ABS(RTIME1-RTIME2)
      RVAL=RVAL+ABS(RVAL1-RVAL2)
  402 CONTINUE
C
      ADD=DD
      IF(P.LT..00001)ROZ=ADD/RVZD    
      IF(P.GE..00001)ROZ=SQRT(ABS(ENTF/P/RVZD*SQRT
     /(ABS((1.-P**2*RV1**2)*(1.-P**2*RVZD**2)))*ADD/RVZD))    
      TTSTAR=RVAL*0.6366*ATAN(1.5923/FHZ)
      RRAMP=RAMP/ROZ
      RRAMP=RRAMP/EXP(3.1416*FHZ*TTSTAR)    
C      RRAMP=RRAMP*SQRT(ABS(RYRO*RVZD*RROZD/RV1/RRO))
C
      RRADI=RADS/EXP(HHH/RADS)
C
CC      IF(ENTF.LE..1)RRAMP=RRAMP/SQRT(EXP(RZSOUR/RADS))    
CC      IF(ENTF.GT..1)RRAMP=RRAMP/SQRT(EXP(RZSOUR/RADS)*ABS(SIN(ENTF/
CC     /RRADI))*RRADI/ENTF)
CC      IF(ENTF.LE..1)RRAMP=RRAMP*RADS/RRADI    
CC      IF(ENTF.GT..1)RRAMP=RRAMP*RADS/RRADI*SQRT(1./ABS(SIN(ENTF/
CC     /RRADI))/RRADI*ENTF)
      IF(ENTF.LE..1)RRAMP=RRAMP/SQRT(EXP(RZSOUR/RADS)*(RRADI/RADS)**3)    
      IF(ENTF.GT..1)RRAMP=RRAMP/SQRT(EXP(RZSOUR/RADS)*ABS(SIN(ENTF/
     /RRADI))*RRADI/ENTF*(RRADI/RADS)**3)
C
      COH=6371.*(1.-1./EXP(HHH/6371.))
      COENTF=ENTF/6371.*180./3.1415926
C           ARRAMP=ALOG10(RRAMP)
C      STRAIN=4.*RRAMP/RV1S*FHZ
C            **          *
C           WRITE(7,376)COENTF,COH,RTIME,RRAMP,ROZ,ADD
  376 FORMAT(3F12.4,F12.5,2F12.3)
      WRITE(7,375)COENTF+RRXS*.00899322,COH
  375 FORMAT(3F12.4,2F12.5)
CC           WRITE(*,*)COENTF,COH,RRAMP,ARRAMP,ADD
      VYS1=SQRT(ABS(SIN(ENTF/RRADI)*RRADI/ENTF))
      VYS2=SQRT(ABS(SIN(ENTF/RADS)*RADS/ENTF))
CC          WRITE(*,*)COH,RRADI,VYS1,VYS2
  401 CONTINUE
      IF(KROK.EQ.1)POL=DD
      IF(KROK.EQ.1)GO TO 20      
      IF(POL.GT.0..AND.DD.LT.0..AND.KS.EQ.0)NDER=NDER+1 
      IF(POL.LT.0..AND.DD.GT.0..AND.KS.EQ.0)NDER=NDER+1 
      IF(POL.GT.0..AND.DD.GT.0..AND.KS.EQ.1)NDER=NDER+1 
      IF(POL.LT.0..AND.DD.LT.0..AND.KS.EQ.1)NDER=NDER+1 
      KS=0     
      POL=DD   
   20 IF(DL1.LT.DL2.AND.J.EQ.I2)GO TO 22     
      IF(DL1.GT.DL2.AND.J.EQ.I1)GO TO 22     
      IF(DL1.LT.DL2)GO TO 9      
      J=J-1    
      GO TO 4  
    9 J=J+1    
      GO TO 14 
   29 IF(P*VU(I1).GT..99999 )K1=3      
      IF(K1.EQ.3)GO TO 18  
      TH=DL1   
      TD=DL2   
      GO TO 38 
   30 IF(P*VL(I2).GT..99999 )K1=3      
      IF(K1.EQ.3)GO TO 18  
      TH=DL2   
      TD=DL1   
   38 TD=AMIN1(TD,H(I1+1))
      KROK=KROK+1
      TH=AMAX1(H(I1),TH)   
      THI=TD-TH      
      ALFA=ATAN(P*VU(I1)/SQRT(1.-P**2*VU(I1)**2)) 
      XD=THI*SIN(ALFA)/COS(ALFA) 
      DDX=DDX+XD     
      IF(K.EQ.0)GO TO 22   
720   CONTINUE 
      TD=THI/COS(ALFA)/VU(I1)    
      VAL=VAL+TD/QF(I1)
      DDT=DDT+TD     
      IF(K.EQ.1)GO TO 22   
      D1=THI*VU(I1)/(COS(ALFA))**3     
      CONTINUE 
      DD=DD+D1 
      IF(KROK.EQ.1)POL=DD  
      IF(KROK.EQ.1)GO TO 22      
      IF(POL.GT.0..AND.DD.LT.0.)NDER=NDER+1  
      IF(POL.LT.0..AND.DD.GT.0.)NDER=NDER+1  
      POL=DD   
   22 IF(DDX.GE..000001)GO TO 5  
      IF(ABS(DDX).GT..000001)GO TO 19  
      DDX=ABS(DDX)   
      DDT=ABS(DDT)   
      GO TO 5  
   19 DDX=-DDX 
      DDT=-DDT 
    5 DX=DX+DDX      
      IF(K.GT.0)DT=DT+DDT
C  T-STAR FOR P/S WAVES
      IF(LQ.EQ.2) VAL = VAL*2.25
C
      TSTAR = TSTAR + ABS(VAL)
C
   18 RETURN    
      END     
